#! /usr/bin/perl

# $Id: webdic.pl,v 1.5 2002/04/22 13:36:55 swaj Exp $ #
# GNU Web dictionary (part of gtkdic package)
# Was written by Alexey Semenov (c) 2001, 2002
# See COPYING for copying policy

require 5.005;
use strict;
use CGI qw/:standard/;
use DBI;

my $DIC_VERSION='0.21';
#---------------------------------------
my $timeout = 180;
my $dbhost = 'localhost';
my $dbname = 'ptkdic';
my $dbuser = 'swaj';
my $dbpass = '';
my $max_search = 100;
#---------------------------------------
my ( $dbh, @dics, %cdbh, $sth, $cur_fin_word, $cur_rus_word, $layout );
$layout = 0; # 1 - lat ; 2 - cyr
$|++;

$SIG{'ALRM'} = sub { $_ = localtime (time); print STDERR "Script timeout: $_\n"; exit; };
alarm $timeout;

my $q = new CGI;
my $sname = $ENV{'SCRIPT_NAME'};
print $q->header ( -expires=>'now' );
print $q->start_html ( -title=> 'GNU Web Dictionary', -BGCOLOR=>'lightblue');
print hr;

if ($ENV{'PATH_INFO'} eq '/help' ) {
    print_help();
    print hr;
} elsif ( ($q->param('word_search')) || ($q->param('art_search'))) {
    print_results();
    print hr;
} else {
    print_form();
    print_about();
    print hr;
}

print $q->end_html;
exit 0;

sub print_help {

    print <<EOF;
    <p>GNU Web dictionary; v$DIC_VERSION.
    Was written by (c) <a href="mailto:swaj\@softhome.net">Alexey Semenov</a>.<br>
    Distributed under <a href="http://www.gnu.org">GPL</a> - The GNU General Public License.
    <p><small><a href="$sname">Main</a>
EOF
}

sub print_form {

    return unless connect_db();

    my $stmt = "show tables";
    unless ( $sth = $dbh->prepare($stmt) ) { print_err (); }
    unless ( $sth->execute ) { print_err (); }
    while ( my @row = $sth->fetchrow_array ) {
        push ( @dics, $row[0]);
        #$_ = $row[0];
    }
    $sth->finish;

    if ( @dics ) {
        foreach my $ttbl ( @dics ) {
            my @tm;
            my $stmt = "describe $ttbl";
            unless ( $sth = $dbh->prepare($stmt) ) { print_err (); }
            unless ( $sth->execute ) { print_err (); }
            while ( my @row = $sth->fetchrow_array ) {
                push ( @tm, $row[0]);
            }
            $_ = join ( '', @tm );
            $ttbl = '' unless ( $_ eq 'art_idwordart_txt');
            $sth->finish;
        }
    }

    foreach ( @dics ) {
        next unless ($_);
        my $bs = $_;
        my $stmt = "select * from $bs where art_id = '3'";
        unless ( $sth = $dbh->prepare($stmt) ) { print_err (); }
        unless ( $sth->execute ) { print_err (); }
        my @row = $sth->fetchrow_array;
        $sth->finish;
        next unless @row;
	$_ = $row[2];
	s|^(.+?)\n.+$|$1|s;

	$stmt = "select count(*) from $_";
	unless ($sth = $dbh->prepare($stmt)) { print_err (); }
	unless ($sth->execute ) { print_err (); }
	my @roww = $sth->fetchrow_array;
	$sth->finish;
	unless (@roww) {
	  print_err ();
	} else {
	  $roww[0] -= 1;
	  $row[1] .= " ($roww[0] words)";
	}

        $cdbh{$row[1]} = $_;
    }

    unless (keys %cdbh) {
	print "No dictionaries found\n";
	disconnect_db();
	return;
    }

    my %cdbhr = reverse (%cdbh);
    my @vals = sort (keys %cdbhr);

    print $q->startform (-method=>'GET');
    print <<EOF;
    <center><table nowrap border=0>
	<tr>
	    <td align=center><i>Dictionary:</i></td>
	    <td align=center><i>Output</i></td>
	</tr>
	<tr><td>
EOF
    print $q->popup_menu( -name=>'dicname', -values=> \@vals, -labels=>\%cdbhr );
    print "</td><td>";
    print $q->popup_menu( -name=>'lout', -values=> [ 'cyrillic', 'latin'] );
    print "</td></tr></table></center>\n";
    print "<center><table nowrap border=0>\n<tr>";
    print "</td><td>\n";
    print $q->submit('word_search','Word search');
    print "</td><td>\n";
    print $q->textfield( -name=>'word', -default=>'', -size=>20, -maxlength=>40);
    print "</td><td>\n";
    print $q->submit('art_search','Article search');
    print "</td><td>\n";
    print $q->textfield( -name=>'art', -default=>'', -size=>20, -maxlength=>40);
    print "</td><td>\n";
    print $q->reset;
    print "</td></tr></table></center>\n";
    print $q->endform;

    disconnect_db(); 
}

sub print_results {

    return unless connect_db();

    my $tbl = $q->param('dicname');
    my $word = $q->param('word');
    my $art = $q->param('art');
    my $sm = 0;
    my $lout = $q->param('lout');
    $layout = 1 if ( $lout =~ /^latin/ );
    $layout = 2 if ( $lout =~ /^cyrillic/ );

    $sm = 1 if $q->param('word_search');
    $sm = 2 if $q->param('art_search');

    if ( ( !$sm ) || ( $sm > 2 ) || ( !$tbl ) ) {
	     print "Invalid query";
	     disconnect_db(); 
	     return;
	 }

    if ( (! $word ) && (! $art ) ) {
	     print "Invalid query<br>";
	     print "<br><a href=\"$ENV{'SCRIPT_NAME'}?dicname=$tbl\">New search</a>\n";
	     disconnect_db(); 
	     return;
	 }

    if ($sm eq 1) {		 #word

	chomp ($word);
	$word =~ s|\\a|\xe4|g;
	$word =~ s|\\A|\xc4|g;
	$word =~ s|\\o|\xf6|g;
	$word =~ s|\\O|\xd6|g;

	$cur_fin_word = $word;

	print_beg_sr ($word);

	my $c_row = 0;
	my $wrd1 = $word;

        my $stmt = sprintf("select art_txt from $tbl where art_id > '9'
                            and word = %s order by word", $dbh->quote($word ));

        unless ($sth = $dbh->prepare($stmt)) { print_err (); }
        unless ($sth->execute ) { print_err (); }
        while ( my @row = $sth->fetchrow_array) {
            $c_row++;
            $_ = $row[0];
            print_text ($_);
	    last if $c_row >= $max_search;
        }
        $sth->finish;

	if ($c_row >= $max_search) {
	    max_search_ex();
	    disconnect_db(); 
	}

	unless ($c_row) {
	    my $wrd2 = '%' . $word . '%';
	    $wrd2 = $dbh->quote( $wrd2 );
	    my $stmt = "select art_txt from $tbl where art_id > '9' and art_txt like $wrd2 order by word";
	    unless ( $sth = $dbh->prepare($stmt) )   { print_err (); }
	    unless ( $sth->execute )                 { print_err (); }
	    while ( my @row = $sth->fetchrow_array ) {
		$c_row++;
		$_ = $row[0];
		print_text ($_);
		last if $c_row >= $max_search;
	    }
	    $sth->finish;
	    if ($c_row >= $max_search) { max_search_ex(); }
	}

    } else {

	$_ = $art;
	chomp;
	$cur_rus_word = $_;
	print_beg_sr ($_);

	my $c_row = 0;
	my $word = $_;
	my $wrd2 = '%' . $_ . '%';
	$wrd2 = $dbh->quote( $wrd2 );
	my $stmt = "select art_txt from $tbl where art_id > '9' and art_txt like $wrd2 order by word";
	unless ( $sth = $dbh->prepare($stmt) )  { print_err (); }
	unless ( $sth->execute )                { print_err (); }
	while ( my @row = $sth->fetchrow_array ) {
	    $c_row++;
	    $_ = $row[0];
	    print_text ($_);
	    last if $c_row >= $max_search;
	}
	$sth->finish;
	if ($c_row >= $max_search) { max_search_ex(); }
    }
	disconnect_db(); 

    print "<br><a href=\"$ENV{'SCRIPT_NAME'}?dicname=$tbl&lout=$lout\">New search</a>\n";
}

#-----------------
sub print_text {

    shift;
    my $c_str;
    my $c_word;
    my  @lines = split /\n/;
    foreach $c_str (@lines) {
        my @words = split ( /\s+/, $c_str );
        for $c_word (@words) {
            $_ = $c_word;
            s|(\d\-\(\))||g;
            s|[\x01-\x20]||g;
            s|\[||g; s|\]||g;
            if(( /[a-zA-z]/ ) && ( /:/ )) {
                insert_latb ("$c_word ");
            } elsif(( /[\x80-\xff]/ ) && ( /:/ )) {
                insert_rusb ("$c_word ");
            } else {
                if ( /[a-zA-z]/ ) {
                    if  ( ($cur_fin_word eq $c_word) || ($cur_rus_word eq $c_word)) {
                        insert_latb ("$c_word ");
                    } else {
                        insert_lat  ("$c_word ");
                    }
                }
                else  {
                    if  ( ($cur_rus_word eq $c_word) || ($cur_fin_word eq $c_word)) {
                        insert_rusb ( "$c_word " );
                    } else {
                        insert_rus ( "$c_word " );
                    }
                }
            }
        }
        print "<br>\n";
    }

    print "<br>\n";
}

sub insert_lat {
    $_ = $_[0];

    if ($layout eq 2) {
	s|\xe4|\\\"a|g;
	s|\xc4|\\\"A|g;
	s|\xf6|\\\"o|g;
	s|\xd6|\\\"O|g;
    }
    print "$_ ";
}

sub insert_rus {
    $_ = $_[0];

    if ($layout eq 1) {
	tr|ţ|abvgdeezijklmnoprstufhye''ABVGDEEZIJKLMNOPRSTUFHYE''|;
	s//ju/g;
	s//JU/g;
	s//ts/g;
	s//TS/g;
	s//zh/g;
	s//ZH/g;
	s//ya/g;
	s//YA/g;
	s//yu/g;
	s//YU/g;
	s//sh/g;
	s//SH/g;
	s//shch/g;
	s//SHCH/g;
	s//ch/g;
	s//CH/g;

	print "<i>$_</i> ";
    } else {
	print "$_ ";
    }
}

sub insert_latb {
    print "<b>";
    insert_lat ($_[0]);
    print "</b>";
}

sub insert_rusb {
    print "<b>";
    insert_rus ($_[0]);
    print "</b>";
}

sub print_beg_sr {
    print "Search results for '$_[0]':<br><br>\n";
}

sub max_search_ex {
    print "<br>Maximum search exceeded<br><br>\n";
}

sub connect_db {
    unless ($dbh = DBI->connect("dbi:mysql:database=$dbname;host=$dbhost", $dbuser, $dbpass)) {
	print_err ("cannot connect to dic database");
	return 0;
    } else {
	return 1;
    }
}

sub disconnect_db {
    $dbh->disconnect if ($dbh) ;
}

sub print_err {
    $_ = $_[0];
    print ("Error: $_\n");
    print STDERR ("$_, reason: $DBI::errstr");
}

sub print_about {
    my $snameh = $sname . '/help';
    print <<EOF;
    <p><table width="100%" border=0 nowrap>
	<tr>
	    <td align=left><small><a href=$snameh>Help</a> </td> 
	    <td align=right><small><small>GNU Web Dictionary. Ver $DIC_VERSION. </td>
	</tr></table>
EOF
}

__END__
