/* $Id: db_sql.c,v 1.9 2003/01/03 09:22:48 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#define __DB_SQL_C_
#include "db_sql.h"
#undef __DB_SQL_C_


gchar* db_init (gchar* host, gchar *dicdb, gchar* user, gchar* passwd)
{
	gint tout = SQL_TIMEOUT;

	search_state = 0;
	LOG("trying to connect to to: host: %s; db: %s; user: %s", host, dicdb, user);

	mysql_init(&dbh);
	mysql_options(&dbh, MYSQL_OPT_CONNECT_TIMEOUT, (gchar*)& tout);

	if ( !(mysql_real_connect(&dbh, host, user, passwd, dicdb, 0, NULL, 0)) ) {
		LOG("mysql_real_connect error: %s", mysql_error(&dbh));
		return (mysql_error(&dbh));
	} else {
		LOG("connect succesful");
		db_state = 1;
		return NULL;
	}
}


void db_shut(void)
{
	if (db_state) {
		LOG("disconnecting");
		mysql_close(&dbh);
	} else {
		LOG("no active connections, just return");
	}
}


gint db_get_tables(void)
{
	MYSQL_RES* result;
	MYSQL_ROW row;

	gchar buf[128], q2[128], temp[128];

	GSList* list = NULL;
	GSList* list2 = NULL;
	GSList* tmp = NULL;
	tinfo = NULL;

	LOG("trying to get available tables");

/* gather available tables */
	if (mysql_query(&dbh,"show tables")) return -1;
	if ((result = mysql_use_result(&dbh))==NULL) return -1;

	while((row = mysql_fetch_row(result))) {
		memset(buf, 0, sizeof(buf));
		g_snprintf(buf, (sizeof(buf)-1), "%s", row[0]);
		list = g_slist_append(list, g_strdup(buf) );
	}
	mysql_free_result(result);

/* check tables structure */
	tmp = list;
	while (tmp != NULL) {

		g_snprintf (q2, sizeof(q2)-1, "describe %s", (char *) GINT_TO_POINTER(tmp->data) );
		g_snprintf (temp, sizeof(temp)-1, "%s", (char *) GINT_TO_POINTER(tmp->data) );

		tmp = g_slist_next(tmp);
	
		if (mysql_query(&dbh,q2)) {
			LOG("mysql error: %s:", mysql_error(&dbh));
			continue;
		}

		if ((result = mysql_use_result(&dbh)) == NULL) {
			LOG("mysql error: %s:", mysql_error(&dbh));
			continue;
		}
		if (!(row = mysql_fetch_row(result))) {
			LOG("query error: %s", mysql_error(&dbh));
			continue;
		}
		g_snprintf (buf, (sizeof(buf)-1),"%s", row[0]);

		if (!(row = mysql_fetch_row(result))) {
			LOG("query error: %s", mysql_error(&dbh));
			continue;
		}

		g_snprintf (buf+strlen(buf), (sizeof(buf)-strlen(buf)-1),"%s", row[0] );

		if (!(row = mysql_fetch_row(result))) {
			LOG("query error: %s", mysql_error(&dbh));
			continue;
		}

		g_snprintf (buf+strlen(buf), (sizeof(buf)-strlen(buf)-1),"%s", row[0] );
		mysql_free_result(result);

		if ( strcmp (buf, TABLE_STRING) != 0 ) {
			LOG("strcmp error: %s != %s", buf, TABLE_STRING );
			continue;
		}

		g_snprintf (q2, sizeof(q2)-1, "select word, art_txt from %s where art_id = '3'", temp);
/*		LOG("list2 stored >%s<", q2); */
		list2 = g_slist_append(list2, g_strdup(q2) );

	}

/* gather row with parametres */

	tmp = list2;

	while (tmp != NULL) {

		g_snprintf(q2, sizeof(q2)-1, GINT_TO_POINTER(tmp->data) );
		tmp = g_slist_next(tmp);

		if (mysql_query(&dbh,q2)) {
			LOG ("query = >%s<", q2);
			LOG("query error: %s", mysql_error(&dbh));
					continue;
		}

		result = mysql_use_result(&dbh);

		while((row = mysql_fetch_row(result))) {
		g_snprintf (buf, (sizeof(buf)-1),"%s\n%s", row[0], row[1]);
		tinfo = g_slist_append(tinfo, g_strdup(buf) );

		}
	}

	ut_slist_free (list);
	ut_slist_free (list2);

	LOG("found %d dics", g_slist_length(tinfo));
	return g_slist_length(tinfo);
}


void db_select_table (char *table)
{
	g_snprintf(db_table, sizeof(db_table), "%s", table);
}


gchar* db_get_table_size(void) {

	MYSQL_RES* result;
	MYSQL_ROW row;

	static gchar buf[64];
	gchar q2[128];

	g_snprintf(q2, sizeof(q2), "select count(*) from %s", db_table);
	LOG("query = %s", q2);

	if (mysql_query(&dbh,q2)) return NULL;
	if ((result = mysql_use_result(&dbh))==NULL) return NULL;

	row = mysql_fetch_row(result);

	memset(buf, 0, sizeof(buf));
	g_snprintf(buf, sizeof(buf), "%s", row[0]);
	mysql_free_result(result);

	if (strlen(buf)==0) {
		return NULL;
	} else {
		LOG("table %s", buf);
		return buf;
	}
}


gchar* db_update_table (gchar *word, gchar *art)
{
	static gchar buf[256];
	gchar *word_c, *art_c;
	gchar *q2 = NULL;	
	gchar *txt = NULL;

	LOG("update_db");

	art_id = db_get_table_max();
	
	LOG("max art_id = %d", art_id);

	if (art_id <= 0) {
		LOG("invalid max_id");
		g_snprintf(buf, sizeof(buf), "Cannot update dictionary %s, table is corrupted?", current_dic );
		return buf;
	}
	art_id++;
	LOG("new art_id = %d", art_id);
	txt = g_malloc (strlen (word) + strlen (art) + 10);
	g_snprintf (txt, strlen (word) + strlen (art) + 10, "%s:\n%s", word, art); 

	word_c = g_malloc (strlen (word) * 2 + 1);

	if (mysql_escape_string(word_c, word, strlen (word)) == 0) {
		LOG("mysql_escape_string error");
		g_free(txt);
		g_free(word_c);
		return ("Unknown error");
	}

	art_c = g_malloc (strlen (txt) * 2 + 1);

	if (mysql_escape_string(art_c, txt, strlen (txt)) == 0) {
		LOG("mysql_escape_string error");
		g_free(txt);
		g_free(word_c);
		g_free(art_c);
		return ("Unknown error");
	}
	g_free(txt);

	q2 = g_malloc ( strlen (word_c) + strlen (art_c) + 512);

	g_snprintf(q2, strlen (word_c) + strlen (art_c) + 512,
		   "insert into %s values (%d, \"%s\", \"%s\")", db_table, art_id, word_c, art_c);
	LOG("query = %s", q2);

	if (mysql_query(&dbh,q2)) { 
		g_snprintf (buf, sizeof(buf), "Cannot update dictionary %s",mysql_error(&dbh)); 
		LOG("%s", buf);
		g_free(word_c);
		g_free(art_c);
		return buf;
	} else {
		g_free(word_c);
		g_free(art_c);

		if (first_art_id == 0) {
			first_art_id = art_id;
			
		}
		return NULL;
	}
}


gchar* db_undo_update_last (void)
{
	LOG("undo last");

	if (art_id <= 0) {
		LOG ("was no inserts before");
		return ("There were no updates");
	} else {
		return (db_undo_v(art_id));
	}
}


gchar* db_undo_update_all (void)
{
	LOG("undo all");

	if (first_art_id <= 0) {
		LOG ("was no inserts before");
		return ("There were no updates");
	} else {
		return (db_undo_v(first_art_id));
	}
}


static
gchar* db_undo_v (int my_art_id)
{
	gchar q2[128];
	static gchar buf[256];

	my_art_id--;
	g_snprintf(q2, sizeof(q2), "delete from %s where art_id > %d", db_table, my_art_id);
	LOG("query = %s", q2);

	if (mysql_query(&dbh,q2)) { 
		g_snprintf (buf, sizeof(buf), "Mysql error: %s",mysql_error(&dbh)); 
		LOG("%s", buf);
		return buf;
	} else {
		return NULL;
	}
}


static
gint db_get_table_max(void) {

	MYSQL_RES* result;
	MYSQL_ROW row;
	int max_id;

	static gchar buf[64];
	gchar q2[128];

	g_snprintf(q2, sizeof(q2), "select max(art_id) from %s", db_table);
	LOG("query = %s", q2);

	if (mysql_query(&dbh,q2)) return 0;
	if ((result = mysql_use_result(&dbh))==NULL) return 0;

	row = mysql_fetch_row(result);

	memset(buf, 0, sizeof(buf));
	g_snprintf(buf, sizeof(buf), "%s", row[0]);
	mysql_free_result(result);

	if (strlen(buf)==0) {
		return 0;
	} else {
		LOG("max art_id %s", buf);
		max_id = strtol (buf, NULL, 10);
		if (max_id == 0) return 0;
		if (max_id < 11) return 10;
		return max_id;
	}
}


gint db_init_search_word (gchar* word, s_mode mode)
{
	gchar q2[256];

	if (search_state) {
		LOG("clear previous search first");
		return -1;
	}

	switch (mode) {
	case S_WORD_NORM:
	case S_WORD_INCREMENT:
  		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and word = \'%s\' order by 1",
			    db_table, word);
		break;
	case S_WORD_NORM_GLOB:
	case S_WORD_GLOB_ONLY:
  		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and word like \'%%%s%%\' order by 1",
			    db_table, word);
		break;
	case S_WORD_GLOB_RIGHT:
  		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and word like \'%s%%\' order by 1",
			    db_table, word);
		break;
	case S_ART_NORM:
		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and art_txt like \'%% %s %%\' order by 1",
			    db_table, word);
		break;
	case S_ART_BOUNDARY_LEFT:
		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and art_txt like \'%% %s%%\' order by 1",
			    db_table, word);
		break;
	case S_ART_BOUNDARY_RIGHT:
		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and art_txt like \'%%%s %%\' order by 1",
			    db_table, word);
		break;
	case S_ART_BOUNDARY_BOTH:
		g_snprintf (q2, sizeof(q2),
		  "select art_txt from %s where art_id > '9' and art_txt like \'%%%s%%\' order by 1",
			    db_table, word);
		break;
	default:
		LOG("unknown mode: %d", mode);
		return -1;
	}
	LOG("init, query = >%s<", q2);
	if (mysql_query(&dbh, q2)) {
		LOG("query error: %s", mysql_error(&dbh));
		return -1;
	}
	if ((db_result = mysql_use_result(&dbh))==NULL) {
		LOG("query error: %s", mysql_error(&dbh));
		return -1;
	}
	search_state = 1;

	return 0;
}


MYSQL_ROW* db_search_word (void)
{
	if (!search_state) {
		LOG("was no search init before");
		return NULL;
	}

	if ((db_row = mysql_fetch_row(db_result))) {
		return &db_row;
	} else {
		LOG("query error or end of search: %s", mysql_error(&dbh));
		return NULL;
	}
} 


void db_end_search_word (void)
{
	if (!search_state) {
		LOG("was no search init before");
		return;
	} else {
		mysql_free_result(db_result);
		search_state = 0;
		return;
	}
}


void db_reset_max_artid(void)
{
	art_id = 0;
	first_art_id = 0;
}



/* __END__ */
