/* $Id: db_sql.h,v 1.9 2003/01/03 09:22:48 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#ifndef __DB_SQL_H_
#define __DB_SQL_H_ 1

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USE_MYSQL

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <glib.h>
#include <mysql.h>

#include "logging.h"
#include "util.h"

#define SQL_TIMEOUT 5

#define TABLE_STRING "art_idwordart_txt"

typedef enum {
	S_WORD_NORM,
	S_WORD_NORM_GLOB,
	S_WORD_GLOB_ONLY,
	S_WORD_GLOB_RIGHT,
	S_WORD_INCREMENT,
	S_ART_NORM,
	S_ART_BOUNDARY_LEFT,
	S_ART_BOUNDARY_RIGHT,
	S_ART_BOUNDARY_BOTH
} s_mode;


gchar* db_init (gchar* ,gchar*, gchar*, gchar*);
void db_shut(void);
gint db_get_tables(void);
void db_select_table (gchar*);
gint db_init_search_word (gchar*, s_mode);
MYSQL_ROW* db_search_word (void);
void db_end_search_word (void);
gchar* db_get_table_size(void);
gchar* db_update_table (gchar*, gchar*);
gchar* db_undo_update_last (void);
gchar* db_undo_update_all (void);

void db_reset_max_artid(void);



#ifdef  __DB_SQL_C_ /* Private declarations */

static gchar* db_undo_v (gint);
static gint db_get_table_max(void);

static MYSQL dbh;
static int db_state = 0;
GSList* tinfo;

static gchar db_table[64];
static gint search_state;
static MYSQL_ROW db_row;
static MYSQL_RES* db_result;

extern gchar current_dic[256];

static gint art_id = 0;
static gint first_art_id = 0;


#endif /* __DB_SQL_C_ */

#endif /* USE_MYSQL */


#endif /* __DB_SQL_H_ */



/* __END__ */
