/* $Id: gtkdic.c,v 1.29 2003/01/24 18:47:21 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#define __GTKDIC_C_
#include "gtkdic.h"
#undef __GTKDIC_C_


int main (int argc, char **argv)
{

#include "but_x.xpm"
#ifdef USE_AUDIO
#include "but_sound.xpm"
#endif /* USE_AUDIO */
#include "green.xpm"
#include "red.xpm"
#include "yellow.xpm"

	GtkWidget *box, *box1, *box2, *box3, *box4, *box_i, *box4l, *box4m;
#ifdef USE_AUDIO
	GtkWidget *box_ia, *but0a;
#endif /* USE_AUDIO */
	GtkWidget *vscroll;
	gchar *err;
	gint font_err = 0;

	mnu1=optmenu=text1=text2=text_output=NULL;

#ifdef USE_X_CLIPBOARD
	memset (xclip_lastword, 0, sizeof (xclip_lastword));
#endif /* USE_X_CLIPBOARD */

	gtk_set_locale();

#ifdef HAVE_SYSLOG_H
	openlog((strchr(argv[0], G_DIR_SEPARATOR) == NULL) ?
		  argv[0] : (strrchr(argv[0], G_DIR_SEPARATOR) + 1),LOG_CONS | LOG_PID, LOG_WARNING);
#endif
	disable_settings = disable_about = 0;
	art = word = NULL;
	memset (current_dic, 0 , sizeof (current_dic));
	memset (file_save_name, 0, sizeof(file_save_name));
	ut_init_history ();

#ifdef HAVE_SIGNAL_H
	signal (SIGTERM, (void*)actual_quit); 
	signal (SIGHUP, (void*)actual_quit); 
	signal (SIGQUIT, (void*)actual_quit); 
	signal (SIGINT, (void*)actual_quit); 
#endif /*  HAVE_SIGNAL_H */

	ut_mask_sigsegv();
	config = cfg_read();

/* GTK stuff */
	gtk_init(&argc, &argv);

	g_snprintf(prog_name, sizeof(prog_name), "%s", *argv);
	LOG("prog_name = >%s<", prog_name);
	norm_cursor = gdk_cursor_new (GDK_LEFT_PTR);
	busy_cursor = gdk_cursor_new (GDK_WATCH);

	mw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_realize(mw);
	set_window_icon (mw);

	dpy = GDK_WINDOW_XDISPLAY(GTK_WIDGET(mw)->window);

	gtk_signal_connect (GTK_OBJECT (mw), "delete_event",
			    (GtkSignalFunc) actual_quit_nosave, NULL);
	gtk_container_border_width (GTK_CONTAINER (mw), 0);

	gtk_signal_connect_object(GTK_OBJECT(mw),"key_press_event",
				  GTK_SIGNAL_FUNC(altq_key_cb),GTK_OBJECT(mw));

	gtk_window_set_default_size (GTK_WINDOW(mw), config->geom.w, config->geom.h);
	gtk_widget_set_uposition(mw, config->geom.x,  config->geom.y);

	box = gtk_vbox_new(FALSE, 1);

	gtk_container_border_width(GTK_CONTAINER(box), MSPACE);
	gtk_container_add(GTK_CONTAINER(mw), box);

	box1 = gtk_vbox_new(TRUE, 1);
	gtk_container_border_width(GTK_CONTAINER(box1), SPACE);
	gtk_box_pack_start(GTK_BOX(box), box1, FALSE, FALSE, 0);

	box2 = gtk_hbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(box2), SPACE);
	gtk_box_pack_start(GTK_BOX(box), box2, FALSE, FALSE, 0);

	box3 = gtk_hbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(box3), SPACE);
	gtk_container_add(GTK_CONTAINER(box), box3);

	box4 = gtk_hbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(box4), SPACE_NFO);
	gtk_box_pack_start(GTK_BOX(box), box4, FALSE, FALSE, 0);

 /* menu */
	 get_main_menu(mw, &menubar1);
	 gtk_box_pack_start(GTK_BOX(box1), menubar1, FALSE, TRUE, 0);

 /* 2 */

	 optmenu = gtk_option_menu_new ();
	 gtk_box_pack_start(GTK_BOX(box2), optmenu, FALSE, TRUE, 0);

#ifdef USE_AUDIO
	 but0a = gtk_button_new();

	 box_ia = gtk_hbox_new (FALSE, 0);
	 pixmap_s = gdk_pixmap_create_from_xpm_d (mw->window, &mask, &mw->style->bg[GTK_STATE_NORMAL], but_sound_xpm);
	 pixmapwid_s = gtk_pixmap_new (pixmap_s, mask);	 

	 gtk_box_pack_start (GTK_BOX (box_ia),pixmapwid_s, FALSE, FALSE, 3);

	 gtk_container_add (GTK_CONTAINER (but0a), box_ia);
	 gtk_widget_show(pixmapwid_s);

	 gtk_container_add(GTK_CONTAINER(box2), but0a);

	 if (strlen (config->speech_prg) == 0) {
		 LOG("config.speech_prg == 0");
		 gtk_widget_set_sensitive (GTK_WIDGET(but0a), FALSE);
	 } else {
		 gtk_signal_connect(GTK_OBJECT(but0a),"clicked",GTK_SIGNAL_FUNC(audio_output),NULL);
	 }

#endif /* USE_AUDIO */

	 but1 = gtk_button_new();
	 lab1  = gtk_label_new (EMPTY);

	 but0 = gtk_button_new();

	 box_i = gtk_hbox_new (FALSE, 0);
	 pixmap = gdk_pixmap_create_from_xpm_d (mw->window, &mask, &mw->style->bg[GTK_STATE_NORMAL], but_x);
	 pixmapwid = gtk_pixmap_new (pixmap, mask);	 

	 gtk_box_pack_start (GTK_BOX (box_i),pixmapwid, FALSE, FALSE, 3);
	 gtk_container_add (GTK_CONTAINER (but0), box_i);
	 gtk_widget_show(pixmapwid);
	 gtk_box_pack_start (GTK_BOX (box2),but0, FALSE, FALSE, 0);
	 gtk_signal_connect(GTK_OBJECT(but0),"clicked",GTK_SIGNAL_FUNC(clear_text_entry),NULL);
	 gtk_container_add(GTK_CONTAINER(but1), lab1);
	 gtk_box_pack_start (GTK_BOX (box2),but1, FALSE, FALSE, 0);
	 combo1 = gtk_combo_new ();
	 gtk_container_add(GTK_CONTAINER(box2), combo1);
	 gtk_signal_connect(GTK_OBJECT(but1),"clicked",GTK_SIGNAL_FUNC(search_word),lab1);

	 gtk_signal_connect_object(GTK_OBJECT (GTK_ENTRY(GTK_COMBO(combo1)->entry )) , "key_press_event", GTK_SIGNAL_FUNC(history_word),GTK_OBJECT  (GTK_ENTRY(GTK_COMBO(combo1)->entry)));

	 gtk_combo_disable_activate(GTK_COMBO(combo1));
	 gtk_combo_set_use_arrows_always (GTK_COMBO(combo1), TRUE);

	 but2 = gtk_button_new();
	 lab2  = gtk_label_new (EMPTY);

	 gtk_container_add(GTK_CONTAINER(but2), lab2);
//	 gtk_container_add(GTK_CONTAINER(box2), but2);
	 gtk_box_pack_start (GTK_BOX (box2),but2, FALSE, FALSE, 0);

	 combo2 = gtk_combo_new ();
	 gtk_container_add(GTK_CONTAINER(box2), combo2);
	 gtk_signal_connect(GTK_OBJECT(but2),"clicked",GTK_SIGNAL_FUNC(search_art),lab2);
	 gtk_signal_connect_object(GTK_OBJECT (GTK_ENTRY(GTK_COMBO(combo2)->entry )) , "key_press_event", GTK_SIGNAL_FUNC(history_art),GTK_OBJECT  (GTK_ENTRY(GTK_COMBO(combo2)->entry)));

	 gtk_combo_disable_activate(GTK_COMBO(combo2));
	 gtk_combo_set_use_arrows_always (GTK_COMBO(combo2), TRUE);

 /* 3 */
	text1 = gtk_text_new (NULL, NULL);
	gtk_text_set_editable (GTK_TEXT (text1), TRUE);
	gtk_text_set_word_wrap(GTK_TEXT (text1),TRUE);

	vscroll = gtk_vscrollbar_new (GTK_TEXT (text1)->vadj);
	gtk_box_pack_start(GTK_BOX(box3), text1, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(box3), vscroll, FALSE, TRUE, 0);

	gtk_signal_connect_object(GTK_OBJECT(text1),"key_press_event",GTK_SIGNAL_FUNC(text1_key_cb),GTK_OBJECT(text1));
	gtk_signal_connect_object(GTK_OBJECT(text1),"button_press_event",GTK_SIGNAL_FUNC(text1_mouse_cb),GTK_OBJECT(text1));
/* 4 */
	box4l = gtk_hbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(box4l), 0);
	gtk_box_pack_start(GTK_BOX(box4), box4l, FALSE, FALSE, 0);


	box4m = gtk_hbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(box4m), 0);
	gtk_box_pack_start(GTK_BOX(box4), box4m, TRUE, TRUE, 0);

	box4r = gtk_hbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(box4r), 0);
	gtk_box_pack_start(GTK_BOX(box4), box4r, FALSE, FALSE, 0);

	pixmap_g = gdk_pixmap_create_from_xpm_d (mw->window, &mask, &mw->style->bg[GTK_STATE_NORMAL], green_xpm);
	pixmap_r = gdk_pixmap_create_from_xpm_d (mw->window, &mask, &mw->style->bg[GTK_STATE_NORMAL], red_xpm);
	pixmap_y = gdk_pixmap_create_from_xpm_d (mw->window, &mask, &mw->style->bg[GTK_STATE_NORMAL], yellow_xpm);
	
	pixmapwid_g = gtk_pixmap_new (pixmap_g, mask);
	pixmapwid_r = gtk_pixmap_new (pixmap_r, mask);
	pixmapwid_y = gtk_pixmap_new (pixmap_y, mask);

/* left status */
	lab3  = gtk_label_new (EMPTY);
	gtk_box_pack_start(GTK_BOX(box4l), lab3, FALSE, FALSE, 0);

/* right status */

	 gtk_box_pack_start (GTK_BOX (box4r),pixmapwid_g, FALSE, FALSE, 5);
	 gtk_box_pack_start (GTK_BOX (box4r),pixmapwid_r, FALSE, FALSE, 5);
	 gtk_box_pack_start (GTK_BOX (box4r),pixmapwid_y, FALSE, FALSE, 5);

	 gtk_widget_show_all(mw);
	 hide_all_indicators();

	 if (!config->parse_ok) {
		LOG("cfg read error");
		print_err("Unable to read configuration file");
	 }

/* Gtk done, SQL prepare */ 

	if (strcmp(config->passwd, "ask")!=0) {
		err = db_init(config->host, config->dicdb, config->user, config->passwd);
	} else {
		ask_which_db();
		err = db_init(config->host, config->dicdb, config->user, config->passwd);
	}

	if (err) {
		print_err(err);
		LOG("db init error: %s", err);
	}

	gtk_widget_show_all(mw);
	hide_all_indicators();

	if ((font_lat = gdk_font_load (config->font_lat)) == NULL) {
		LOG("cannot load font font_lat = %s, trying %s",config->font_lat, DEFAULT_FONT);  
		font_lat = gdk_font_load (DEFAULT_FONT);
		font_err++;
	}

	if ((font_latb = gdk_font_load (config->font_latb)) == NULL) {
		LOG("cannot load font font_latb = %s, trying %s",config->font_latb, DEFAULT_FONT);  
		font_latb = gdk_font_load (DEFAULT_FONT);
		font_err++;
	}

	if ((font_rus  = gdk_font_load (config->font_rus)) == NULL) {
		LOG("cannot load font font_rus = %s, trying %s",config->font_rus, DEFAULT_FONT);  
		font_rus = gdk_font_load (DEFAULT_FONT);
		font_err++;
	}

	if ((font_rusb = gdk_font_load (config->font_rusb)) == NULL) {
		LOG("cannot load font font_rusb = %s, trying %s",config->font_rusb, DEFAULT_FONT);  
		font_rusb = gdk_font_load (DEFAULT_FONT);
		font_err++;
	}

	if (font_err) {
		LOG("%d fonts missed, replaced with '%s'", font_err, DEFAULT_FONT);
		print_err ("Unable to load some fonts , check configuration file");
	}

	init_styles();

	set_mw_norm();
	init_text_w();

#ifdef USE_AUDIO
	if (strlen (config->speech_prg) == 0) {
		LOG("config.speech_prg == 0");
		print_err("speech program not specified");
	}
#endif /* USE_AUDIO */


#ifdef USE_SOCKET
	if (sock_lsnr_init()) {
		LOG("socket init ok");
		gdk_input_add (sock_fd,GDK_INPUT_READ, sock_lsnr, NULL);
	}
#endif /* USE_SOCKET */

	get_dictionaries_menu();
	gtk_widget_show_all(mw);
	hide_all_indicators();

	status_bar(ST_OK);
	define_output_window1();
	gtk_main();
	return 0;
}
/* main end */


void get_dictionaries_menu (void)
{
	gint a;
	GSList* temp;
	gchar *ptr, *def_dic=NULL, buf[256];
	GtkWidget *item;

	memset(buf, 0, sizeof(buf));

	if (mnu1 != NULL) g_free(mnu1);

	mnu1 = gtk_menu_new ();
	a = db_get_tables();

	switch (a) {
	case -1:
		LOG("cannot get information about dictionaries");
		print_err("cannot get information about dictionaries");
	case 0:       
		LOG("no dictionaries found");
		print_err("no dictionaries found");
	default:
		LOG("changing option menu");

		temp = tinfo;
		a = 0;
		while (temp != NULL) {
			g_snprintf(buf, sizeof(buf), "%s",(char *)GINT_TO_POINTER(temp->data)); 
			if ((ptr = strtok (buf, "\n")) != NULL) {
				ptr = g_strdup(ptr);
				item = gtk_menu_item_new_with_label(ptr);
				gtk_object_set_data(GTK_OBJECT(item), "value", ptr);
				gtk_signal_connect(GTK_OBJECT(item), "activate", (GtkSignalFunc) change_dic, ptr);
				if (!a) {
					def_dic = ptr;
				}
				gtk_menu_append(GTK_MENU (mnu1), item);
                                /* gtk_widget_show(item); visible dics */
			}
			temp = g_slist_next(temp);
			a++;
		}
		gtk_option_menu_set_menu ((GtkOptionMenu*)optmenu, mnu1);
	}

		if (strlen(config->cur_dic) >0) {
			change_dic_v (config->cur_dic);
	} else {
		change_dic_v (def_dic);
	}
}


void set_window_icon (GtkWidget *w)
{

#include "icon.xpm"
	GdkPixmap *pixmap;
	GdkBitmap *mask;

	pixmap = gdk_pixmap_create_from_xpm_d (w->window, &mask, &w->style->bg[GTK_STATE_NORMAL], icon);
	gdk_window_set_icon (w->window, NULL, pixmap, mask);
	return;
}


void get_main_menu(GtkWidget *window, GtkWidget **menubar)
{
	gint nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);

	GtkItemFactory *item_factory;
	GtkAccelGroup *accel_group;

	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",
                                       accel_group);
	gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);

#ifdef GTK_IS_1_2
	gtk_accel_group_attach (accel_group, GTK_OBJECT (window));
#endif /* GTK_IS_1_2 */

#ifdef GTK_IS_2_0
	gtk_accel_group_attach (accel_group, G_OBJECT(window));

#endif /* GTK_IS_2_0 */


	if (menubar) *menubar = gtk_item_factory_get_widget(item_factory, "<main>");
}


static
void ask_which_db(void)
{
	GtkWidget *dialog, *but, *box1, *box2, *box2a, *box3, *box4;
	GtkWidget *lab, *lab1, *lab1a, *lab2, *lab3;

	LOG("ask_which_db");

	dialog =  gtk_dialog_new ();
        gtk_widget_realize(dialog);
        gdk_window_set_decorations(GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);
        gdk_window_set_functions (GTK_WIDGET(dialog)->window, GDK_FUNC_MOVE);
        set_window_icon(GTK_WIDGET(dialog));
        
        gtk_window_set_title(GTK_WINDOW(dialog), "Database connection");
        gtk_container_border_width(GTK_CONTAINER(dialog), 5);

        gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
        gtk_widget_show(dialog);

	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);

        box1 = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box1), 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box1, TRUE, TRUE, 0);

        box2 = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box2), 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box2, TRUE, TRUE, 0);

        box2a = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box2a), 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box2a, TRUE, TRUE, 0);

        box3 = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box3), 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box3, TRUE, TRUE, 0);

        box4 = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box4), 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box4, TRUE, TRUE, 0);


	lab = gtk_label_new ("DB connection information:");
        gtk_box_pack_start (GTK_BOX (box1), lab, TRUE, TRUE, 30);

	lab1 = gtk_label_new ("Host:      ");
        gtk_box_pack_start (GTK_BOX (box2), lab1, TRUE, TRUE, 30);
	entry1 = gtk_entry_new_with_max_length ( 40 );
	gtk_entry_set_text(GTK_ENTRY(entry1), config->host);
        gtk_box_pack_start (GTK_BOX (box2), entry1, TRUE, TRUE, 30);

	lab1a = gtk_label_new ("DB-name:");
        gtk_box_pack_start (GTK_BOX (box2a), lab1a, TRUE, TRUE, 30);
	entry1a = gtk_entry_new_with_max_length ( 40 );
	gtk_entry_set_text(GTK_ENTRY(entry1a), config->dicdb);
        gtk_box_pack_start (GTK_BOX (box2a), entry1a, TRUE, TRUE, 30);

	lab2 = gtk_label_new ("User:      ");
        gtk_box_pack_start (GTK_BOX (box3), lab2, TRUE, TRUE, 30);
	entry2 = gtk_entry_new_with_max_length ( 40 );
	gtk_entry_set_text(GTK_ENTRY(entry2), config->user);
        gtk_box_pack_start (GTK_BOX (box3), entry2, TRUE, TRUE, 30);

	lab3 = gtk_label_new ("Passwd:   ");
        gtk_box_pack_start (GTK_BOX (box4), lab3, TRUE, TRUE, 30);
	entry3 = gtk_entry_new_with_max_length ( 40 );
	gtk_entry_set_visibility(GTK_ENTRY(entry3), FALSE);
	gtk_entry_set_text(GTK_ENTRY(entry3), config->passwd);
        gtk_box_pack_start (GTK_BOX (box4), entry3, TRUE, TRUE, 30);

        but = gtk_button_new_with_label( "OK" );
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 0);

        gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_ask_which_db, GTK_OBJECT(dialog));
        gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_ask_which_db),GTK_OBJECT(dialog));
        gtk_widget_show_all (dialog);

	stop_need = 1;

	while (stop_need) {
		gtk_main_iteration();
	}
}


static
void destroy_ask_which_db (GtkWidget* dialog)
{
        LOG("destroying ask_which_db dialog");

	strncpy (config->host, gtk_entry_get_text (GTK_ENTRY(entry1)), sizeof(config->host)-1);
	strncpy (config->dicdb, gtk_entry_get_text (GTK_ENTRY(entry1a)), sizeof(config->dicdb)-1);
	strncpy (config->user, gtk_entry_get_text (GTK_ENTRY(entry2)), sizeof(config->user)-1);
	strncpy (config->passwd, gtk_entry_get_text (GTK_ENTRY(entry3)), sizeof(config->passwd)-1);
	stop_need = 0;
        gtk_widget_destroy(dialog);
}


static 
void reconnect_db(void)
{
	gchar *err;

	LOG("reconnect");
	db_shut();
	ask_which_db();
	err = db_init(config->host, config->dicdb, config->user, config->passwd);

	if (err) {
		print_err(err);
		LOG("db init error: %s", err);
		status_bar(ST_QUERY_DB);
		db_error = 1;

		gtk_widget_set_sensitive (GTK_WIDGET(combo1), FALSE);
		gtk_widget_set_sensitive (GTK_WIDGET(combo2), FALSE);

		gtk_widget_set_sensitive (GTK_WIDGET(optmenu), FALSE);

		gtk_widget_set_sensitive (GTK_WIDGET(but0), FALSE);
		gtk_widget_set_sensitive (GTK_WIDGET(but1), FALSE);
		gtk_widget_set_sensitive (GTK_WIDGET(but2), FALSE);



	} else {
		get_dictionaries_menu();
		gtk_widget_show_all(mw);
		status_bar(ST_OK);
		print_msg("DB change ok");
		db_error = 0;

		gtk_widget_set_sensitive (GTK_WIDGET(combo1), TRUE);
		gtk_widget_set_sensitive (GTK_WIDGET(combo2), TRUE);

		gtk_widget_set_sensitive (GTK_WIDGET(optmenu), TRUE);

		gtk_widget_set_sensitive (GTK_WIDGET(but0), TRUE);
		gtk_widget_set_sensitive (GTK_WIDGET(but1), TRUE);
		gtk_widget_set_sensitive (GTK_WIDGET(but2), TRUE);

	}
}


static
void hide_all_indicators(void)
{
	gtk_widget_hide(GTK_WIDGET(pixmapwid_g));
	gtk_widget_hide(GTK_WIDGET(pixmapwid_r));
	gtk_widget_hide(GTK_WIDGET(pixmapwid_y));

}


/* __END__ */
