/* $Id: gtkdic.h,v 1.15 2003/01/03 09:22:48 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#ifndef __GTKDIC_H_
#define __GTKDIC_H_ 1

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif /* HAVE_SIGNAL_H */

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif /* HAVE_SYSLOG_H */

#include <errno.h>
#include <glib.h>
#include <mysql.h>
#include <gtk/gtk.h>
#include <gtk/gtkhbox.h>
#include <gdk/gdkx.h>

#ifdef GTK_IS_2_0
#define GTK_ENABLE_BROKEN 1
#include <gtk/gtktext.h>
#include <gtk/gtkaccelgroup.h>
#endif /* GTK_IS_2_0 */

#include "logging.h"
#include "cfg.h"
#include "db_sql.h"
#include "util.h"
#include "gtkdic_cb.h"

#define MSPACE 0
#define SPACE 0
#define SPACE_NFO 5
#define ENTRY_LEN 50
#define MAX_LINES_IN_RESULT 400
#define MAX_WORD_IN_LINE 200
#define EMPTY "      "

#ifndef DEFAULT_FONT
#define DEFAULT_FONT "fixed"
#endif

void set_window_icon (GtkWidget*);

#ifdef  __GTKDIC_C_ /* Private declarations */

static void get_main_menu(GtkWidget*, GtkWidget**);
static void ask_which_db(void);
static void destroy_ask_which_db (GtkWidget* dialog);
static void reconnect_db(void);
static void hide_all_indicators(void);
static void get_dictionaries_menu (void);



#ifdef GTK_IS_2_0
void gtk_accel_group_attach (GtkAccelGroup  *accel_group, GObject        *object)
{
	_gtk_accel_group_attach (accel_group, object);
}
#endif /* GTK_IS_2_0 */



#ifdef USE_SOCKET
extern int sock_fd;
#endif /* USE_SOCKET */

extern GSList* tinfo;
extern gint disable_settings;
extern gint disable_about;
extern gchar file_save_name[512];
extern gchar current_dic[256];
extern guchar xclip_lastword[256];

static GtkItemFactoryEntry menu_items[] = {

	{"/_File",         	"<control>F",	NULL, 0, "<Branch>"	},
	{"/File/New window",   	NULL,		new_window, 0, NULL	},
	{"/File/_Clear",   	"<control>C",	clear_text, 0, NULL	},
	{"/File/Open ...",   	NULL,		open_file, 0, NULL	},
	{"/File/Save as...",   	NULL,		save_file, 0, NULL	},
	{"/File/_Print",   	"<control>P",	print_out, 0, NULL	},

	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	{"/File/Find text",     NULL,	        search_text, 0, NULL	},
	{"/File/Redraw text",  NULL,		redraw_text, 0, NULL	},
#ifdef USE_EDIT
	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	 {"/File/_Update dictionary",   NULL,	update_db, 0, NULL	},
	 {"/File/Undo last update",   	NULL,	undo_update_last, 0, NULL },
	 {"/File/Undo all updates",   	NULL,	undo_update_all, 0, NULL },
#endif /* USE_EDIT */
	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	 {"/File/_Settings",	"<control>S",	settings, 0, NULL	},

	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	 {"/File/Translate selected",   	"<control>T",	search_word_sep, 0, NULL },
	 {"/File/Reverse translate selected",	"<control>R",	search_art_sep, 0, NULL	},
	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	{"/File/Change DB",  NULL, 	        reconnect_db, 0, NULL	},

	{"/File/sep1",     	NULL,         	NULL, 0, "<Separator>"	},
	{"/File/Quit",     	"<control>Q", 	about_quit, 0, NULL	},

	{"/Help",      		NULL,         	NULL, 0, "<LastBranch>"	},
	{"/Help/About",		NULL,         	about_dialog, 0, NULL	}
};

GtkWidget *mw, *but0, *but1, *but2, *combo1, *combo2;
GtkWidget *text1, *text2, *text_output;
GtkWidget *menubar1,  *lab1, *lab2, *lab3;
GtkWidget *entry1, *entry1a, *entry2, *entry3;
GdkFont *font_lat, *font_latb, *font_rus, *font_rusb;
GdkCursor *norm_cursor, *busy_cursor;

GdkPixmap *pixmap, *pixmap_g, *pixmap_r, *pixmap_y;
GdkBitmap *mask;
GtkWidget *pixmapwid, *pixmapwid_g, *pixmapwid_r, *pixmapwid_y;
GtkWidget *mnu1, *optmenu;
GtkWidget *box4r;

#ifdef USE_AUDIO
GdkPixmap *pixmap_s;
GtkWidget *pixmapwid_s;
#endif /* USE_AUDIO */

Cfg *config;
gchar *word, *art;
gint stop_need = 0;
gint db_error = 0;
gchar prog_name[256];

Display *dpy;




#endif /* __GTKDIC_C_ */



#endif /* __GTKDIC_H_ */



/* __END__ */
