/* $Id: gtkdic_cb.c,v 1.36 2003/01/31 08:48:18 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#define __GTKDIC_CB_C_ 1
#include "gtkdic_cb.h"
#undef  __GTKDIC_CB_C_


void about_quit (void)
{
	GtkWidget *dialog, *lab, *but, *but2;
	gchar buf[256];

	LOG("about_quit");
	err_stop=1;
	g_snprintf(buf, sizeof(buf), "   Quit: Are you sure?   ");
	dialog =  gtk_dialog_new ();
	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_widget_realize(dialog);

	gdk_window_set_decorations(GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);
	gdk_window_set_functions (GTK_WIDGET(dialog)->window, GDK_FUNC_MOVE);
	set_window_icon(GTK_WIDGET(dialog));
	gtk_window_set_title(GTK_WINDOW(dialog), "Are you sure?");
	gtk_widget_show(dialog);
	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);
	gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_about_quit_no,GTK_OBJECT(dialog));

	lab = gtk_label_new (buf);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), lab, TRUE, TRUE, 10);

	but = gtk_button_new_with_label( "Yes" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_about_quit_yes),GTK_OBJECT(dialog));
	but2 = gtk_button_new_with_label( "No" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but2, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but2),"clicked",GTK_SIGNAL_FUNC(destroy_about_quit_no),GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);

	while (err_stop) {
		gtk_main_iteration();
	}
}


static
void destroy_about_quit_no (GtkWidget *d)
{
	gtk_widget_destroy(d);
	err_stop=0;
}


static
void destroy_about_quit_yes (GtkWidget *d)
{
	gtk_widget_destroy(d);
	actual_quit();
}


void actual_quit_nosave(void)
{
	nsconf = 0;
	actual_quit();
}


void actual_quit(void)
{
	db_shut();

	if (nsconf) {
		LOG("we need to save conf");
		gdk_window_get_geometry (mw->window, &config->geom.x, &config->geom.y, &config->geom.w, &config->geom.h, NULL);

		//gdk_window_get_position (mw->window, &config->geom.x, &config->geom.y );
		gdk_window_get_root_origin (mw->window, &config->geom.x, &config->geom.y );

		/* check geom validity */
		unless (VALIDATE(config->geom.h, DEFAULT_GEOMETRY_MAX_H)) {
			LOG("wrong high, using default value");
			config->geom.h = DEFAULT_GEOMETRY_H;
		}
		unless (VALIDATE(config->geom.w, DEFAULT_GEOMETRY_MAX_W)) {
			LOG("wrong width, using default value");
			config->geom.w = DEFAULT_GEOMETRY_W;
		}
		unless (VALIDATE(config->geom.x, DEFAULT_GEOMETRY_MAX_X)) {
			LOG("wrong x position, using default value");
			config->geom.x = DEFAULT_GEOMETRY_X;
		}
		unless (VALIDATE(config->geom.y, DEFAULT_GEOMETRY_MAX_Y)) {
			LOG("wrong y position, using default value");
			config->geom.y = DEFAULT_GEOMETRY_Y;
		}


		cfg_save();
	} else {
		LOG("dont save config");
	}

	err_stop=0;
	LOG("quitting now...");

#ifdef USE_SOCKET
	if (strlen(config->sock_lsn)) unlink (config->sock_lsn);
#endif /* USE_SOCKET */

	gtk_main_quit();
}


void print_err (gchar *err_txt)
{
	print_err_v (PR_ERR, err_txt); 
}


void print_msg (gchar *err_txt)
{
	print_err_v (PR_MSG, err_txt); 
}


static
void print_err_v (PR_MODE mode, gchar *err_txt)
{
	GtkWidget *dialog, *lab, *but;
	gchar buf[256];
	gchar msg1[64];
	gchar msg2[64];
	
	err_stop = 1;

	LOG("print out error: %s", err_txt );

	switch (mode) {
	case PR_MSG:
		g_snprintf (msg1, sizeof(msg1), "       MESSAGE:       \n");
		g_snprintf (msg2, sizeof(msg2), "Message");
		break;
	case PR_ERR:
		g_snprintf (msg1, sizeof(msg1), "        ERROR:        \n");
		g_snprintf (msg2, sizeof(msg2), "Error");
		break;
	default:
		LOG("unknown mode = %d", mode);
		return;
	}

	g_snprintf(buf, sizeof(buf), "%s%s", msg1, err_txt);

	dialog =  gtk_dialog_new ();
	gtk_window_set_title(GTK_WINDOW(dialog), msg2);

	gtk_container_border_width(GTK_CONTAINER(dialog), 5);

	gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_dialog,GTK_OBJECT(dialog));
	lab = gtk_label_new (buf);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), lab, TRUE, TRUE, 30);
	gtk_widget_show (lab);

	but = gtk_button_new_with_label( "OK" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 0);
	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_dialog),GTK_OBJECT(dialog));
	gtk_widget_show (but);
	gtk_widget_show(dialog);

	while (err_stop) {
		gtk_main_iteration();
	}
}


void change_dic (GtkWidget* widget)
{
	change_dic_v (gtk_object_get_data(GTK_OBJECT(widget), "value"));
}


void change_dic_v (gchar *p)
{
	gchar buf[128], berr[128], or_buff[128];
	gchar *ptr;
	gint a;
	GSList* temp;
	gchar *pp;
	gchar null_str[] = " ";

	LOG("changing dic to: >%s<", p);

	if (p == NULL) {
		p = null_str;
	}

	g_snprintf (current_dic, sizeof (current_dic), "%s", p);
	g_snprintf (buf, sizeof(buf), "%s: %s", PACKAGE, p); 
	gtk_window_set_title(GTK_WINDOW(mw), buf);

	g_snprintf (berr, sizeof(berr), "Unable to find dictionary: \"%s\"", p);
	g_snprintf (or_buff, sizeof(or_buff), "%s", p);

	temp = tinfo;

		while (temp != NULL) {
				memset (buf, 0, sizeof(buf));
				strncpy (buf, (char *)GINT_TO_POINTER(temp->data), sizeof(buf)-1);

				temp = g_slist_next(temp);

				if (strncmp(buf, or_buff, strlen(or_buff)) == 0) {

					g_snprintf (config->cur_dic, sizeof(config->cur_dic), "%s", or_buff);

					if ((pp = strtok(buf, "\n")) == NULL) {
						LOG("error");
						return;
					}
				/* table */
					if ((pp = strtok(NULL, "\n")) == NULL) {
						LOG("error");
						return;
					} else {
						LOG("table = %s", pp);
						db_select_table (pp);
					}
				/* left button */
					if ((pp = strtok(NULL, "\n")) == NULL) {
						LOG("error");
						return;
					} else {
						LOG("but1 = %s", pp);
						gtk_label_set ((GtkLabel *)lab1, pp);
					}
				/* font for left button */
					if ((pp = strtok(NULL, "\n")) == NULL) {
						LOG("error");
						return;
					} else {
						LOG("font entry1  = %s", pp);

						switch (*pp) {
						case 'l':
							style_left = style_lat;
							gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(GTK_COMBO(combo1)->entry)), style_lat);
							break;
						case 'r':
							style_left = style_rus;
							gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(GTK_COMBO(combo1)->entry)), style_rus);
							break;
						default:
							LOG("invalid font %s", pp);
						}
					}
				/* right button */
					if ((pp = strtok(NULL, "\n")) == NULL) {
						LOG("error");
						return;
					} else {
						LOG("but2 = %s", pp);
						gtk_label_set ((GtkLabel *)lab2, pp);
					}
				/* font for right button */
					if ((pp = strtok(NULL, "\n")) == NULL) {
						LOG("error");
						return;
					} else {
						LOG("font entry2  = %s", pp);

						switch (*pp) {
						case 'l':
							style_right = style_lat;
							gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(GTK_COMBO(combo2)->entry)), style_lat);
							break;
						case 'r':
							style_right = style_rus;
							gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(GTK_COMBO(combo2)->entry)), style_rus);
							break;
						default:
							LOG("invalid font %s", pp);
						}
					}

					if ((ptr = db_get_table_size()) != NULL) {
						a = strtod(ptr, NULL);
						a--;
						g_snprintf (buf+strlen(buf), sizeof(buf)-strlen(buf), ": %d words",a);
						gtk_label_set ((GtkLabel *)lab3, buf);
					}
					db_reset_max_artid();
					return;

				} else {
					continue;
				}
		}

		print_err(berr);
		LOG("strange, unable to find in tinfo");
}


static
void clear_text_sep(void)
{

	LOG("now clearing text (sep win");

	if (text2 != NULL) {



		gtk_editable_delete_text(GTK_EDITABLE (text2), 0, gtk_text_get_length (GTK_TEXT(text2)));

	} else {
		LOG("text2 == null");
	}
}


void clear_text(void)
{
	LOG("now clearing text (main win)");

	gtk_editable_delete_text(GTK_EDITABLE (text1), 0, gtk_text_get_length (GTK_TEXT(text1)));

}


static
void clear_sep_win_if_need(void)
{
	if (config->clear_new_search) {
		clear_text_sep();
	}
}


void clear_txt_if_need (void)
{
	if (config->clear_new_search) {
		clear_text();
	}
}


static
void clear_any_txt(void)
{
	LOG("here");
	if (text2 != NULL) {
		clear_sep_win_if_need();
	} else {
		clear_txt_if_need();
	}
}


void clear_text_entry (GtkWidget* w)
{
	LOG("now clearing text and entries");
	gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), "");
	gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo2)->entry), "");
}


void search_word(void)
{
	gint a = 0, i;
	GList *glist=NULL;

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	if (config->w_search_mode != S_WORD_INCREMENT) { 
		word = (gchar *) gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));
	} else {
		word = increment_word;
	}
	LOG("now search word >%s<", word);

	define_output_window();

	status_bar(ST_QUERY_DB);

	if (word == NULL) {
		LOG("word == NULL");
		return;
	}

	if (strlen(word) == 0) {
		LOG("word len = 0, do nothing");
		return;
	}
	ut_umltotxt (word);

	LOG("search mode = %d", config->w_search_mode);

	gtk_text_freeze (GTK_TEXT(text_output));
	set_mw_busy();

	switch (config->w_search_mode) {
	case S_WORD_NORM:
		clear_any_txt();
		//clear_txt_if_need();
		db_init_search_word (word, S_WORD_NORM);
		while ((my_row = db_search_word()) != NULL) {
			print_text_with_separator_after (*my_row[0]);
			if (a++ >= config->max_search) {
				print_text (MAX_SEARCH_EXCEEDED_MSG);
				LOG(MAX_SEARCH_EXCEEDED_MSG);
				break;
			}
		}
		LOG("found %d article(s)", a);
		db_end_search_word();
		break;

	case S_WORD_INCREMENT:
		db_init_search_word (word, S_WORD_NORM);
		while ((my_row = db_search_word()) != NULL) {
			if (!a) {
				//clear_txt_if_need();
				clear_any_txt();
			}
			print_text_with_separator_after (*my_row[0]);
			if (a++ >= config->max_search) {
				print_text (MAX_SEARCH_EXCEEDED_MSG);
				LOG(MAX_SEARCH_EXCEEDED_MSG);
				break;
			}
		}
		LOG("found %d article(s)", a);
		db_end_search_word();
		if (a == 0) {
			LOG("no exact matches, trying glob right");
			db_init_search_word (word, S_WORD_GLOB_RIGHT);
			while ((my_row = db_search_word()) != NULL) {
				if (!a) {
					//clear_txt_if_need();
					clear_any_txt();
				}
				print_text_with_separator_after (*my_row[0]);
				if (a++ >= MAX_SEARCH_IN_INCREMENT) {
					LOG("exceeded max search in increment");
					break;
				}
			}
			LOG("found %d article(s)", a);
			db_end_search_word();
		}

		if (a == 0) {			 /* search in articles */
			LOG("no exact matches, trying glob in articles");
			db_init_search_word (word, S_ART_BOUNDARY_BOTH);
			while ((my_row = db_search_word()) != NULL) {
				print_text_with_separator_after (*my_row[0]);
				if (a++ >= config->max_search) {
					print_text (MAX_SEARCH_EXCEEDED_MSG);
					LOG(MAX_SEARCH_EXCEEDED_MSG);
					break;
				}
			}
			LOG("found %d article(s)", a);
			db_end_search_word();
		}
		break;

	case S_WORD_NORM_GLOB:
		//clear_txt_if_need();
		clear_any_txt();
		db_init_search_word (word, S_WORD_NORM);
		while ((my_row = db_search_word()) != NULL) {
			print_text_with_separator_after(*my_row[0]);
			if (a++ >= config->max_search) {
				print_text (MAX_SEARCH_EXCEEDED_MSG);
				LOG(MAX_SEARCH_EXCEEDED_MSG);
				break;
			}
		}
		LOG("found %d article(s)", a);
		db_end_search_word();

		if (a == 0) {
			LOG("no exact matches, trying glob");
			db_init_search_word (word, S_WORD_GLOB_ONLY);
			while ((my_row = db_search_word()) != NULL) {
				print_text_with_separator_after(*my_row[0]);
				if (a++ >= config->max_search) {
					print_text (MAX_SEARCH_EXCEEDED_MSG);
					LOG(MAX_SEARCH_EXCEEDED_MSG);
					break;
				}
			}
			LOG("found %d article(s)", a);
			db_end_search_word();
		}

		if (a == 0) {			 /* search in articles */
			LOG("no exact matches, trying glob in articles");
			db_init_search_word (word, S_ART_BOUNDARY_BOTH);
			while ((my_row = db_search_word()) != NULL) {
				print_text_with_separator_after (*my_row[0]);
				if (a++ >= config->max_search) {
					print_text (MAX_SEARCH_EXCEEDED_MSG);
					LOG(MAX_SEARCH_EXCEEDED_MSG);
					break;
				}
			}
			LOG("found %d article(s)", a);
			db_end_search_word();
		}
		break;

	case S_WORD_GLOB_ONLY:
		//clear_txt_if_need();
		clear_any_txt();
		db_init_search_word (word, S_WORD_GLOB_ONLY);
		while ((my_row = db_search_word()) != NULL) {
			print_text_with_separator_after (*my_row[0]);
			if (a++ >= config->max_search) {
				print_text (MAX_SEARCH_EXCEEDED_MSG);
				LOG(MAX_SEARCH_EXCEEDED_MSG);
				break;
			}
		}
		LOG("found %d article(s)", a);
		db_end_search_word();

		if (a == 0) {			 /* search in articles */
			LOG("no exact matches, trying glob in articles");
			db_init_search_word (word, S_ART_BOUNDARY_BOTH);
			while ((my_row = db_search_word()) != NULL) {
				print_text_with_separator_after (*my_row[0]);
				if (a++ >= config->max_search) {
					print_text (MAX_SEARCH_EXCEEDED_MSG);
					LOG(MAX_SEARCH_EXCEEDED_MSG);
					break;
				}
			}
			LOG("found %d article(s)", a);
			db_end_search_word();
		}
		break;

	default:
		LOG("invalid search mode: %d", config->w_search_mode);
	}
	if ((a) && (config->w_search_mode != S_WORD_INCREMENT)) { 
		ut_insert_history_word(word);
		for (i=0; i< HIST_LEN; i++) {
			if (strlen (word_history[i]) > 0) {
				glist = g_list_append(glist, word_history[i]);
			}
		}
		my_gtk_combo_set_popdown_strings_l( GTK_COMBO(combo1), glist) ;
		g_list_free(glist);
	}

	gtk_text_thaw (GTK_TEXT(text_output));
	set_mw_norm();
	status_bar(ST_OK);
	return;
}


void search_art(void)
{
	gint a = 0, i;
	GList *glist=NULL;

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	art = (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry));

	LOG("now search art >%s<", art);

	define_output_window();
	status_bar(ST_QUERY_DB);

	if (art == NULL) {
		LOG("art == NULL");
		return;
	}
	if (strlen(art) == 0) {
		LOG("art len = 0, do nothing");
		return;
	}

	clear_any_txt();

	ut_umltotxt (art);

	LOG("search mode = %d", config->a_search_mode);

	gtk_text_freeze (GTK_TEXT(text_output));
	set_mw_busy();

	switch (config->a_search_mode) {

	case S_ART_NORM:
	case S_ART_BOUNDARY_LEFT:
	case S_ART_BOUNDARY_RIGHT:
	case S_ART_BOUNDARY_BOTH:
		db_init_search_word (art, config->a_search_mode);
		while ((my_row = db_search_word()) != NULL) {
			print_text_with_separator_after (*my_row[0]);
			if (a++ >= config->max_search) {
				print_text (MAX_SEARCH_EXCEEDED_MSG);
				LOG(MAX_SEARCH_EXCEEDED_MSG);
				break;
			}
		}
		LOG("found %d article(s)", a);
		db_end_search_word();
		break;
	default:
		LOG("invalid search mode: %d", config->a_search_mode);
	}
	if (a) {
		ut_insert_history_art(art);
		for (i=0; i< HIST_LEN; i++) {
			if (strlen (art_history[i]) > 0) {
				glist = g_list_append(glist, art_history[i]);
			}
		}
		my_gtk_combo_set_popdown_strings_r( GTK_COMBO(combo2), glist) ;
		g_list_free(glist);
	}
	gtk_text_thaw (GTK_TEXT(text_output));
	set_mw_norm();
	status_bar(ST_OK);
	return;
}

void define_output_window(void)
{
	LOG("now here");

	text_output =  text2 != NULL ? text2 : text1; 
}


void define_output_window1(void)
{
	LOG("now here");

	text_output =  text1; 
}


void print_text_with_separator_after (gchar *txt)
{
	print_text (txt);
	print_text (SEARCH_SEPARATOR);
}


void print_text (gchar *txt)
{
	gchar buf[256];
	gchar **ss, **ss2;
	gint a,b, bold;
	gint first_word;

	if ((ss = g_strsplit(txt, "\n", MAX_LINES_IN_RESULT)) == NULL) {
		LOG("error - NULL after g_strsplit result");
		return;
	}

	for (a=0; a < MAX_LINES_IN_RESULT; a++) {
		if (ss[a] == NULL) break;

		first_word = 1;

		if ((ss2 = g_strsplit(ss[a], " ", MAX_WORD_IN_LINE)) == NULL) {
			LOG("error - NULL after g_strsplit line");
			return;
		}
		for (b=0; b < MAX_WORD_IN_LINE; b++) {
			if (ss2[b] == NULL) break;
			/* word print */

			/* FIXING 
			 * ut_umltotxt(ss2[b]);
			 */

			bold = 0;

			if ((a == 0) && (b==0)) {
				bold = 1;
			}

			if ((!bold) && ( ut_is_word_bold(ss2[b]))) {
				bold = 1;
			}

			if ((!bold) && (word != NULL) && (strlen(word) > 0))  {
				if (strncmp (word, ss2[b], strlen(word)) == 0) {
					bold = 1;
				} else {
					bold = 0;
				}
			}

			if ((!bold) && (art != NULL) && (strlen(art) >0)) {  
//				if (strncmp (art, ss2[b],   strlen(art)) == 0) {
				if (strstr (ss2[b], art) != NULL) {

					bold = 1;
				} else {
					bold = 0;
				}
			}

			if (first_word) {
				g_snprintf(buf, sizeof(buf), "%s", ss2[b]); 
				first_word = 0;
			} else {
				g_snprintf(buf, sizeof(buf), " %s", ss2[b]); 
			}

			if (ut_is_word_latin(buf)) {

				if (bold) {
					gtk_text_insert (GTK_TEXT (text_output), font_latb,
							 color_fg, NULL, buf,-1);
				} else {
					gtk_text_insert (GTK_TEXT (text_output), font_lat,
							 color_fg, NULL, buf,-1);
				}
			} else {
				if (bold) {
					gtk_text_insert (GTK_TEXT (text_output), font_rusb,
							 color_fg, NULL, buf,-1);
				} else {
					gtk_text_insert (GTK_TEXT (text_output), font_rus,
							 color_fg, NULL, buf,-1);
				}
			}
		}
		g_strfreev(ss2);
		gtk_text_insert (GTK_TEXT (text_output), font_rus, color_fg, NULL, "\n", -1);
	}

	g_strfreev(ss);
}


static 
void destroy_dialog (GtkWidget* dialog)
{
	LOG("destroying dialog");
	err_stop = 0;
	gtk_widget_destroy(dialog);
}


static
void destroy_settings (GtkWidget* dialog)
{
	LOG("destroying settings");
	disable_settings = 0;
	gtk_widget_destroy(dialog);
}


void settings(void)
{
	GtkWidget *dialog, *frame1, *frame2, *frame3, *box1, *box2;
	GtkWidget *box_rbw, *box_rba, *box_rbc, *but, *rb, *rb2, *cb1; /*, *cb2;*/
	GtkWidget *lab1, *sb1, *box3;
	GtkAdjustment *adj;
	GSList *group, *group2;

	gint w_s_m = config->w_search_mode;
	gint a_s_m = config->a_search_mode;

	LOG("settings menu");
	if (disable_settings) {
		LOG("disable_settings = 1, ret");
		return;
	}
	disable_settings = 1;

	dialog =  gtk_dialog_new ();
	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE); //CENTER);

	gtk_widget_realize(dialog);

	gdk_window_set_decorations( GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|  GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);
//	gdk_window_set_functions ( GTK_WIDGET(dialog)->window, GDK_FUNC_MOVE);

	set_window_icon(GTK_WIDGET(dialog));

	gtk_window_set_title(GTK_WINDOW(dialog), "Settings");
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);
	gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_settings, NULL);
	
	but = gtk_button_new_with_label( "OK" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 0);
	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_settings),GTK_OBJECT(dialog));

/* upper */
	box1 = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), box1, TRUE, TRUE, 10);

	box2 = gtk_vbox_new(FALSE, 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), box2, TRUE, TRUE, 10);

	frame1 = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (box1),frame1, TRUE, TRUE, 0);
	gtk_frame_set_label( GTK_FRAME(frame1), "Word search" );

	frame2 = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (box1),frame2, TRUE, TRUE, 0);
	gtk_frame_set_label(GTK_FRAME(frame2), "Article search" );

	frame3 = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (box2),frame3, TRUE, TRUE, 0);
	gtk_frame_set_label(GTK_FRAME(frame3), "Miscellaneous" );

	gtk_frame_set_label_align(GTK_FRAME(frame1), 1.0, 0.0);
	gtk_frame_set_label_align(GTK_FRAME(frame2), 1.0, 0.0);
	gtk_frame_set_label_align(GTK_FRAME(frame3), 1.0, 0.0);

/* radiobutt. word  */
	box_rbw = gtk_vbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box_rbw), 10);
	gtk_container_add(GTK_CONTAINER(frame1), box_rbw);

	rb = gtk_radio_button_new_with_label (NULL, "Exact match only");

	group = gtk_radio_button_group (GTK_RADIO_BUTTON (rb));
	gtk_box_pack_start (GTK_BOX (box_rbw), rb, FALSE, FALSE, 0);

	if (config->w_search_mode == S_WORD_NORM) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb), TRUE);
	gtk_signal_connect_object (GTK_OBJECT (rb), "clicked", GTK_SIGNAL_FUNC (word_search_mode1), NULL );

	rb = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb)),"Exact, glob if not found");
	if (config->w_search_mode == S_WORD_NORM_GLOB) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb), TRUE);
	gtk_box_pack_start (GTK_BOX (box_rbw), rb, FALSE, FALSE, 0);
	gtk_signal_connect_object (GTK_OBJECT (rb), "clicked", GTK_SIGNAL_FUNC (word_search_mode2), NULL );

	rb = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb)),"Glob match only");
	if (config->w_search_mode == S_WORD_GLOB_ONLY) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb), TRUE);
	gtk_box_pack_start (GTK_BOX (box_rbw), rb, FALSE, FALSE, 0);
	gtk_signal_connect_object (GTK_OBJECT (rb), "clicked", GTK_SIGNAL_FUNC (word_search_mode3), NULL );

	rb = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb)),"Incremental");
	if (config->w_search_mode == S_WORD_INCREMENT) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb), TRUE);
	gtk_box_pack_start (GTK_BOX (box_rbw), rb, FALSE, FALSE, 0);
	gtk_signal_connect_object (GTK_OBJECT (rb), "clicked", GTK_SIGNAL_FUNC (word_search_mode4), NULL );

/* radiobutt. art  */
	box_rba = gtk_vbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(box_rba), 10);
	gtk_container_add(GTK_CONTAINER(frame2), box_rba);

	rb2 = gtk_radio_button_new_with_label (NULL, "Word boundary\n   >* PATTERN *<");
	group2 = gtk_radio_button_group (GTK_RADIO_BUTTON (rb2));
	gtk_box_pack_start (GTK_BOX (box_rba), rb2, TRUE, TRUE, 0);
	if (config->a_search_mode == S_ART_NORM) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb2), TRUE);

	gtk_signal_connect_object (GTK_OBJECT (rb2), "clicked", GTK_SIGNAL_FUNC (art_search_mode1), NULL );

	rb2 = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb2)),"Word boundary left\n   >* PATTERN*<");
	gtk_box_pack_start (GTK_BOX (box_rba), rb2, TRUE, TRUE, 0);
	if (config->a_search_mode == S_ART_BOUNDARY_LEFT) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb2), TRUE);
	gtk_signal_connect_object (GTK_OBJECT (rb2), "clicked", GTK_SIGNAL_FUNC (art_search_mode2), NULL );

	rb2 = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb2)),"Word boundary right\n   >*PATTERN *<");
	gtk_box_pack_start (GTK_BOX (box_rba), rb2, TRUE, TRUE, 0);
	if (config->a_search_mode == S_ART_BOUNDARY_RIGHT) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb2), TRUE);

	gtk_signal_connect_object (GTK_OBJECT (rb2), "clicked", GTK_SIGNAL_FUNC (art_search_mode3), NULL );

	rb2 = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (rb2)),"No boundary\n   >*PATTERN*<");
	gtk_box_pack_start (GTK_BOX (box_rba), rb2, TRUE, TRUE, 0);
	gtk_signal_connect_object (GTK_OBJECT (rb2), "clicked", GTK_SIGNAL_FUNC (art_search_mode4), NULL );
	if (config->a_search_mode == S_ART_BOUNDARY_BOTH) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (rb2), TRUE);

/* checkbutt.  */
	box_rbc = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(box_rbc), 5);
	gtk_container_add(GTK_CONTAINER(frame3), box_rbc);
        gtk_widget_show(box_rbc);

	cb1 = gtk_check_button_new_with_label( "Clear before new search" );
	gtk_box_pack_start (GTK_BOX (box_rbc), cb1, FALSE, FALSE, 10);
	gtk_signal_connect (GTK_OBJECT (cb1), "clicked", GTK_SIGNAL_FUNC (toggle_clear), cb1 );
	if (config->clear_new_search) {
		gtk_toggle_button_set_active ( (GtkToggleButton *)  (cb1), TRUE );
	}

	box3 = gtk_hbox_new(FALSE, 5);
	gtk_container_border_width(GTK_CONTAINER(box3), 0);
	gtk_container_add(GTK_CONTAINER(box_rbc), box3);

	adj = (GtkAdjustment *) gtk_adjustment_new (1.0, 1.0, 1000.0, 1.0, 0.0, 0.0);

	sb1 = gtk_spin_button_new(adj, 0,0);

	gtk_spin_button_set_value((GtkSpinButton *) sb1, (gfloat) config->max_search);
	gtk_signal_connect (GTK_OBJECT (adj),"value_changed",GTK_SIGNAL_FUNC(change_max_search),(gpointer)sb1);

	gtk_box_pack_start (GTK_BOX (box3), sb1,FALSE, FALSE, 5); 
	lab1 = gtk_label_new("Max search");
	gtk_box_pack_start (GTK_BOX (box3), lab1, FALSE, TRUE, 0);

/* done  */
	config->w_search_mode = w_s_m;
	config->a_search_mode = a_s_m;

	gtk_widget_show_all (dialog);
}


static
void change_max_search(GtkWidget *widget, GtkSpinButton *spin)
{
	config->max_search = gtk_spin_button_get_value_as_int(spin);
	LOG("change max search to %d", config->max_search);
}


static 
void word_search_mode1 (GtkWidget *widget, gpointer data )
{
	config->w_search_mode = S_WORD_NORM;
	LOG("word_search_mode = %d", config->w_search_mode);
}


static 
void word_search_mode2 (GtkWidget *widget, gpointer data )
{
	config->w_search_mode = S_WORD_NORM_GLOB;
	LOG("word_search_mode = %d", config->w_search_mode);
}


static 
void word_search_mode3 (GtkWidget *widget, gpointer data )
{
	config->w_search_mode = S_WORD_GLOB_ONLY;
	LOG("word_search_mode = %d", config->w_search_mode);
}


static 
void word_search_mode4 (GtkWidget *widget, gpointer data )
{
	memset(increment_word, 0, sizeof(increment_word));
	config->w_search_mode = S_WORD_INCREMENT;
	LOG("word_search_mode = %d", config->w_search_mode);
}


static 
void art_search_mode1 (GtkWidget *widget, gpointer data)
{
	config->a_search_mode = S_ART_NORM;
	LOG("art_search_mode = %d", config->a_search_mode);
}


static 
void art_search_mode2 (GtkWidget *widget, gpointer data)
{
	config->a_search_mode = S_ART_BOUNDARY_LEFT;
	LOG("art_search_mode = %d", config->a_search_mode);
}


static
void art_search_mode3 (GtkWidget *widget, gpointer data)
{
	config->a_search_mode = S_ART_BOUNDARY_RIGHT;
	LOG("art_search_mode = %d", config->a_search_mode);
}


static
void art_search_mode4 (GtkWidget *widget, gpointer data)
{
	config->a_search_mode = S_ART_BOUNDARY_BOTH;
	LOG("art_search_mode = %d", config->a_search_mode);
}


static
void toggle_clear (GtkWidget *widget, gpointer data)
{
	if (GTK_TOGGLE_BUTTON (widget)->active) {
		config->clear_new_search = TRUE;
	} else {
		config->clear_new_search = FALSE;
	}
	LOG("need_clear = %d", config->clear_new_search);
}


void about_dialog (void)
{
	GtkWidget *dialog, *lab, *but, *box, *pixmap;
	GdkPixmap *pixmap1;
	GdkBitmap *mask;
	GdkColormap *colormap;
	gchar buf[256];

	LOG("about dialog: ");

	if (disable_about) {
		LOG("about already open");
		return;
	}
	disable_about = 1;

	g_snprintf(buf, sizeof(buf), "GNU Gtk Dictionary. Version: %s.\nThis program was written by (c) Alexey Semenov (swaj@softhome.net).\nSee COPYING for license information.\n(build: %s for %s;\nwith GTK+: %s; MySQL: %s)\n", VERSION, DATE, BUILD, GTK_VERSION, MYSQL_VERSION);
	dialog =  gtk_dialog_new ();
	gtk_widget_realize(dialog);
	gdk_window_set_decorations( GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|  GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);
	gdk_window_set_functions ( GTK_WIDGET(dialog)->window, GDK_FUNC_MOVE);
	set_window_icon(GTK_WIDGET(dialog));

	gtk_window_set_title(GTK_WINDOW(dialog), "About");
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_widget_show(dialog);
	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);

	box = gtk_hbox_new(FALSE, 10);

	gtk_container_border_width(GTK_CONTAINER(box), 10);

	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),box, TRUE, TRUE, 0);

	colormap = gtk_widget_get_colormap (dialog);

	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d (dialog->window, colormap, &mask,NULL, logo);
	pixmap = gtk_pixmap_new( pixmap1, mask );
	gtk_box_pack_start (GTK_BOX (box), pixmap, TRUE, TRUE, 0);

	lab = gtk_label_new (buf);
	gtk_box_pack_start (GTK_BOX (box), lab, TRUE, TRUE, 30);
	gtk_widget_show (lab);

	but = gtk_button_new_with_label( "OK" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 0);

	gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_about_dialog, GTK_OBJECT(dialog));

	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_about_dialog),GTK_OBJECT(dialog));
	gtk_widget_show_all (dialog);
}


static
void destroy_about_dialog (GtkWidget* dialog)
{
	LOG("destroying ask dialog");
	disable_about = 0;
	gtk_widget_destroy(dialog);
}


void history_word (GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	gchar *p, *pressed;
	gint ev;

	ev = event->type;
        /* LOG("event->type = %d", ev); */

	switch (event->keyval) {
	case GDK_Up:
		LOG("Up");
		if ((p = ut_fetch_history_word_up()) != NULL) {
			gtk_entry_set_text (GTK_ENTRY(widget), p);
		}
		stop_signal_emit(widget, ev);
		break;
	case GDK_Down:
		LOG("Down");
		if ((p = ut_fetch_history_word_down()) != NULL) {
			gtk_entry_set_text (GTK_ENTRY(widget), p);
		}
		stop_signal_emit(widget, ev);
		break;
	case GDK_Escape:
		LOG("Escape");
		gtk_entry_set_text (GTK_ENTRY(widget), "");
		break;
	case GDK_Return:
		LOG("Return");
		search_word();
		stop_signal_emit(widget, ev);
		break;
	case GDK_Tab:
		stop_signal_emit(widget, ev);

		gtk_signal_emit_by_name (GTK_OBJECT(widget), "activate" );
                /* gtk_signal_emit_by_name (
		   GTK_OBJECT(GTK_BUTTON(GTK_COMBO(combo1)->button)), "clicked" ); */

		break;
	default:
		if (config->w_search_mode == S_WORD_INCREMENT) {
			pressed = gdk_keyval_name(event->keyval);

			if (strlen(pressed) == 1) {
				LOG("pressed `%s' inside word entry",pressed);
				g_snprintf(increment_word, sizeof(increment_word),"%s%s",
					   gtk_entry_get_text (GTK_ENTRY(GTK_COMBO(combo1)->entry)),pressed);
				LOG("%s", increment_word);
				search_word();
				gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), increment_word);
				stop_signal_emit(widget, ev);
			} else {
				if (strcmp (pressed, "BackSpace")!=0) break;
				g_snprintf(increment_word, sizeof(increment_word),"%s",
					   gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry)));
				if (strlen(increment_word) > 0) {
					increment_word[strlen(increment_word)-1] = 0;
					LOG ("%s", increment_word);
					search_word();
				}
				gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), increment_word);
				stop_signal_emit(widget, ev);
			}
		}
     }
}


void history_art (GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	gchar *p;
	gint ev;

	ev = event->type;
        /* LOG("event->type = %d", ev); */

	switch (event->keyval) {
	case GDK_Up:
		LOG("Up");
		if ((p = ut_fetch_history_art_up()) != NULL) {
			gtk_entry_set_text (GTK_ENTRY(widget), p);
		}
		stop_signal_emit(widget, ev);
		break;
	case GDK_Down:
		LOG("Down");
		if ((p = ut_fetch_history_art_down()) != NULL) {
			gtk_entry_set_text (GTK_ENTRY(widget), p);
		}
		stop_signal_emit(widget, ev);
		break;
	case GDK_Escape:
		LOG("Escape");
		gtk_entry_set_text (GTK_ENTRY(widget), "");
		break;
	case GDK_Return:
		LOG("Return");
		search_art();
		stop_signal_emit(widget, ev);
		break;
	case GDK_Tab:
		stop_signal_emit(widget, ev);
		gtk_signal_emit_by_name (GTK_OBJECT(widget), "activate" );
		break;
	default:
		break;
     }
}


static
void stop_signal_emit (GtkWidget *widget, gint ev)
{
	if (ev == GDK_KEY_PRESS) {
		gtk_signal_emit_stop_by_name (GTK_OBJECT (widget), "key_press_event");
		return;
	}
	if (ev == GDK_KEY_RELEASE) {
		gtk_signal_emit_stop_by_name (GTK_OBJECT (widget), "key_release_event");
		return;
	}
}


void print_out (void)
{
	gchar *txt;
	gchar buf[256], buf2[256];
	FILE* flt;
	gchar **ss, **ss2;
	gint a,b, bold;

	LOG("print_out");

	if (strlen (txt = gtk_editable_get_chars (GTK_EDITABLE (text1), 0, -1)) == 0) {
		LOG("text area is empty, no action");
		return;
	}
        /* LOG("txt = %s", txt); */
	g_snprintf (buf2,  sizeof(buf), "%s%s", g_get_home_dir(), WORK_DIR);
	LOG("cddir to %s", buf2);

	if (chdir(buf2) != 0) {
		g_snprintf(buf, sizeof(buf), "cannot chdir to %s: %s", WORK_DIR, strerror(errno));
		LOG("%s", buf);
		print_err(buf);
		return;
	}

	if ((flt = popen("latex > /dev/null 2>&1", "w")) == NULL) {
		g_snprintf(buf, sizeof(buf), "cannot run latex: %s", strerror(errno));
		LOG("%s", buf);
		print_err(buf);
		return;
	}

	status_bar(ST_PRINTING);

	fprintf (flt, "%%\n%% GtkDic latex output\n%%\n%s\n\\begin{document}\n\n", config->latex_preamble);

/* print latex */
	if ((ss = g_strsplit(txt, "\n", MAX_LINES_IN_RESULT)) == NULL) {
		LOG("error - NULL after g_strsplit result");
		pclose(flt);
		return;
	}
	for (a=0; a < MAX_LINES_IN_RESULT; a++) {
		if (ss[a] == NULL) break;

		if (ut_is_line_empty(ss[a])) {
			fprintf(flt, "\n\n\\vspace{10}"); /* empty line */
			continue;
		}

		if ((ss2 = g_strsplit(ss[a], " ", MAX_WORD_IN_LINE)) == NULL) {
			LOG("error - NULL after g_strsplit line");
			pclose(flt);
			return;
		}
		for (b=0; b < MAX_WORD_IN_LINE; b++) {
			if (ss2[b] == NULL) break;
			/* word print */
			bold = 0;

			if ((a == 0) && (b==0)) {
				bold = 1;
			}

			if ((!bold) && ( ut_is_word_bold(ss2[b]))) {
				bold = 1;
			}

			if ((!bold) && (word != NULL) && (strlen(word) > 0))  {
				if (strncmp (word, ss2[b], strlen(word)) == 0) {
					bold = 1;
				} else {
					bold = 0;
				}
			}
			if ((!bold) && (art != NULL) && (strlen(art) >0)) {  

				if (strstr (ss2[b], art) != NULL) {

					bold = 1;
				} else {
					bold = 0;
				}
			}
			g_snprintf(buf, sizeof(buf), " %s", ss2[b]); 

			if (ut_is_word_latin(buf)) {

				if (bold) {
					fprintf(flt, "\\textbf{%s}", ut_add_uml(buf));
				} else {
					fprintf(flt, "%s", ut_add_uml(buf));
				}
			} else {
				if (bold) {
					fprintf(flt, "\\textbf{%s}", buf);
				} else {
					fprintf(flt, "%s", buf);
				}
			}
		}
		g_strfreev(ss2);
		fprintf(flt, "\\\\");
	}
	g_strfreev(ss);
	fprintf (flt, "\n\n\\end{document}\n");
	pclose(flt);
/* end print latex */

	g_snprintf (buf2+strlen(buf2), sizeof(buf)-strlen(buf), "/texput.dvi");

	if (access(buf2, R_OK) != 0) {
		LOG("latex doesnt work, errno = %s", strerror(errno));
		print_err("Seems latex doesn't work properly");
		return;
	}
	g_snprintf (buf, sizeof(buf), "dvips %s", buf2);
	LOG("system >%s<", buf);

	if (system (buf) != 0) {
		LOG("system failed");
		print_err("Seems dvips doesn't work properly");
	}
	status_bar(ST_OK);
	return;
}


void set_mw_norm (void)
{
	gdk_window_set_cursor (mw->window, norm_cursor);
}


void set_mw_busy (void)
{
	gdk_window_set_cursor (mw->window, busy_cursor);
}


void init_styles(void)
{
	style_def = gtk_widget_get_style(mw);
	color_fg = style_def->fg;
	color_bg = style_def->bg;

	color_sel_fg = style_def->bg;
	color_sel_bg = g_malloc(sizeof(GdkColor ));
	gdk_color_parse  (config->bg_color_sel, color_sel_bg);

	style_lat = gtk_style_copy (style_def);
	style_latb = gtk_style_copy (style_def);
	style_rus = gtk_style_copy (style_def);
	style_rusb = gtk_style_copy (style_def);

#ifdef GTK_IS_1_2
	style_lat->font = font_lat;
	style_latb->font = font_latb;
	style_rus->font = font_rus;
	style_rusb->font = font_rusb;
#endif /* GTK_IS_1_2 */


/* TODO

#ifdef GTK_IS_2_0
	style_lat->font_desc))->font = font_lat;
	style_latb->font_desc->font = font_latb;
	style_rus->font_desc->font = font_rus;
	style_rusb->font_desc->font = font_rusb;
#endif GTK_IS_2_0

*/

	style_left = style_right = style_def;
}


static
void my_gtk_combo_set_popdown_strings_l (GtkCombo *combo, GList *strings)
{
	return my_gtk_combo_set_popdown_strings (combo, strings, style_left);
}


static
void my_gtk_combo_set_popdown_strings_r (GtkCombo *combo, GList *strings)
{
	return my_gtk_combo_set_popdown_strings (combo, strings, style_right);
}


static
void my_gtk_combo_set_popdown_strings (GtkCombo *combo, GList *strings, GtkStyle *style)
{
	GList *list;
	GtkWidget *li;

	g_return_if_fail (combo != NULL);
	g_return_if_fail (GTK_IS_COMBO (combo));
	g_return_if_fail (strings != NULL);

	gtk_list_clear_items (GTK_LIST (combo->list), 0, -1);
	list = strings;
	while (list) {
		li = my_gtk_list_item_new_with_label ((gchar *) list->data, style);
		gtk_widget_show (li);
		gtk_container_add (GTK_CONTAINER (combo->list), li);
		list = list->next;
	}
}


static
GtkWidget* my_gtk_list_item_new_with_label (const gchar *label, GtkStyle *style)
{
	GtkWidget *list_item;
	GtkWidget *label_widget;

	list_item = gtk_list_item_new ();
	label_widget = gtk_label_new (label);
	gtk_misc_set_alignment (GTK_MISC (label_widget), 0.0, 0.5);
	gtk_container_add (GTK_CONTAINER (list_item), label_widget);
	gtk_widget_set_style ( GTK_WIDGET (label_widget    ), style);
	gtk_widget_show (label_widget);
	return list_item;
}


void save_file (void)
{
	gchar *txt;
	GtkWidget *filew;
	FILE* fl;
	gchar buf[256];

	LOG("save_file");

	if (strlen (txt = gtk_editable_get_chars (GTK_EDITABLE (text1), 0, -1)) == 0) {
		LOG("text area is empty, no action");
		return;
	}
        /* LOG("txt = %s", txt); */

	filew = gtk_file_selection_new ("Save file...n");
	gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_save_file, &filew);
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) file_ok_sel, filew );
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) destroy_save_file,GTK_OBJECT (filew));

	setup_def_file(filew);

	err_stop = 1;
	file_ok = 0;
	gtk_widget_show(filew);

	while (err_stop) {
		gtk_main_iteration();
	}

	if (!file_ok) {
		return;
	}

	if ((fl = fopen (file_save_name, "w")) == NULL) {
		g_snprintf(buf, sizeof(buf), "Unable to open file: %s", strerror (errno));
		print_err(buf);
		return;
	}

	if (fprintf (fl, "%s", txt) > 0) {
		print_msg("Saving ok");
	} else {
		print_err("Saving error");
	}

	fclose (fl);
}


void open_file (void)
{
	gchar *txt=NULL;
	GtkWidget *filew;
	int fd, len;
	struct stat statv;
	gchar buf[256];

	LOG("open_file");

	filew = gtk_file_selection_new ("Open file...");
	gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_save_file, &filew);
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) file_ok_sel, filew );
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) destroy_save_file,GTK_OBJECT (filew));
	setup_def_file(filew);

	err_stop = 1;
	file_ok = 0;
	gtk_widget_show(filew);

	while (err_stop) {
		gtk_main_iteration();
	}

	if (!file_ok) {
		return;
	}

	if ((fd = open (file_save_name,O_RDONLY )) == 0) {
		g_snprintf(buf, sizeof(buf), "Unable to open file: %s", strerror (errno));
		print_err(buf);
		return;
	}

	memset (&statv, 0, sizeof(statv));

	if (stat(file_save_name, &statv)!=0) {
		LOG("stat error: %s", strerror(errno));
		close (fd);
		return;
	}

	len = statv.st_size;
	txt = g_malloc(len+1);

	memset (txt, 0, len+1);

	read (fd, txt, len);
	ut_replace_control(txt);

	gtk_text_freeze (GTK_TEXT(text1));
	define_output_window1();
	clear_txt_if_need();
	print_text(txt);
	gtk_text_thaw (GTK_TEXT(text1));

	g_free(txt);
	close (fd);
}

static
void file_ok_sel( GtkWidget *w, GtkFileSelection *fs)
{
	g_snprintf (file_save_name, sizeof(file_save_name), "%s",gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs))); 
	LOG("file save = >%s<", file_save_name);
	err_stop = 0;
	file_ok = 1;
	gtk_widget_destroy(GTK_WIDGET(fs));
}


static
void destroy_save_file (GtkWidget* w)
{
	 LOG("destroying file_sel");
	 err_stop = 0;
	 gtk_widget_destroy(w);
}


static
void setup_def_file (GtkWidget *filew)
{
	if (strlen(file_save_name) == 0) {
		g_snprintf (file_save_name, sizeof(file_save_name), "%s%s",g_get_home_dir(), G_DIR_SEPARATOR_S);
	}
	gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew), file_save_name );
}


void new_window(void)
{
	LOG("new window");

        switch (fork()) {
        case -1:                        /* failed */
                LOG("Cant fork: %s",strerror (errno)  );
                exit(1);
        case 0:                         /* child */
		LOG("fork ok, child is running >%s<",prog_name); 
		execlp (prog_name , " ", NULL);
		LOG("execlp failed");
		_exit (0);
		break;
        default:                        /* parent */
		LOG("fork ok, parent");
		break;
        }
}


static
void open_sep_win_if_need(void)
{
	LOG("now here");

	if (text2 != NULL) {
		LOG("already open");
	} else {
		open_sep_win();
	}
}


static
void open_sep_win(void)
{
	GtkWidget *dialog, *but, *box_a, *vscroll;

	LOG("open separate window");

	if (text2 != NULL) {
		LOG("text2 != null, already opened");
		return;
	}

	dialog =  gtk_dialog_new ();
        /* gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE); //CENTER); */

	gtk_widget_realize(dialog);

	gdk_window_set_decorations( GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);

	set_window_icon(GTK_WIDGET(dialog));
	gtk_window_set_title(GTK_WINDOW(dialog), "gtkdic: translation window");
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);

	gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_sepwin, NULL);
	
	but = gtk_button_new_with_label( "Close" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 0);
	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(destroy_sepwin),GTK_OBJECT(dialog));

/* upper */
	box_a = gtk_hbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(box_a), SPACE);
	gtk_container_add(GTK_CONTAINER  (  GTK_BOX (GTK_DIALOG (dialog)->vbox)), box_a);

	text2 = gtk_text_new (NULL, NULL);
	gtk_text_set_editable (GTK_TEXT (text2), TRUE);
	gtk_text_set_word_wrap(GTK_TEXT (text2),TRUE);

	vscroll = gtk_vscrollbar_new (GTK_TEXT (text2)->vadj);
	gtk_box_pack_start(GTK_BOX(box_a), text2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(box_a), vscroll, FALSE, TRUE, 0);

	gtk_window_set_default_size (GTK_WINDOW(dialog), config->geom.w, config->geom.h);
	gtk_widget_show_all (dialog);
}


static
void destroy_sepwin (GtkWidget* dialog)
{
	LOG("destroying sepwin");
	gtk_widget_destroy(dialog);
	text2 = NULL;
}


void text1_mouse_cb(GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	GdkEventButton *bev;

	if (event->type == GDK_BUTTON_PRESS) {
		bev = (GdkEventButton *)event;
	} else {
		return;
	}

	if (bev->button ==3) {
		LOG("search coz but3 pressed");
		search_text();
		gtk_signal_emit_stop_by_name(GTK_OBJECT(text1), "button_press_event");
	}

}


void text1_key_cb(GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	static gint ctrl, alt;
	gchar *pressed;

	pressed = gdk_keyval_name(event->keyval);
	/* LOG("%s",pressed); */ 

	switch (event->keyval) {

	case GDK_Control_L:
	case GDK_Control_R:
		LOG("<Ctrl> detected");
		ctrl = 1;
		break;

	case GDK_Alt_L:
	case GDK_Alt_R:
		LOG("<Alt> detected");
		alt = 1;
		break;

	default:
		if (ctrl) {
			ctrl = 0;
			if (strcasecmp (pressed, "t") == 0) {
				LOG("Ctrl-R");
				search_word_sep();

			} else if (strcasecmp (pressed, "r") == 0) {
				LOG("Ctrl-T"); 
				search_art_sep ();
			} else if (strcasecmp (pressed, "z") == 0) {
				LOG("Ctrl-Z");
				window_iconify_mw();
			}

		} else if (alt) {
			alt = 0;

			if (strcasecmp (pressed, "q") == 0) {
				LOG("Alt-Q");
				actual_quit_nosave();
			} else if (strcasecmp (pressed, "f") == 0) {
				LOG("Alt-F");
				search_text();
				return;
			}

		}
	}
}


void altq_key_cb(GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	static gint ctrl, alt;
	gchar *pressed;
	gint ev;

	pressed = gdk_keyval_name(event->keyval);

	ev = event->type;
	/* LOG("%s",pressed);  */

	switch (event->keyval) {

	case GDK_Control_L:
        case GDK_Control_R:
                LOG("<Ctrl> detected");
                ctrl = 1;
                break;

	case GDK_Alt_L:
	case GDK_Alt_R:
		LOG("<Alt> detected");
		alt = 1;
		break;

	default:
		if (ctrl) {
                        ctrl = 0;
                        if (strcasecmp (pressed, "z") == 0) {
                                LOG("Ctrl-Z");
				window_iconify_mw();
			}

                } else if (alt) {
			alt = 0;
			if (strcasecmp (pressed, "q") == 0) {
				LOG("Alt-Q");
				actual_quit_nosave();
			}

			if (strcasecmp (pressed, "f") == 0) {
				LOG("Alt-F");
				search_text();
				stop_signal_emit(widget, ev);
			}
		}
	}
}


void search_word_sep (void)
{

#ifdef USE_X_CLIPBOARD
	gchar *ptr;
#endif /* USE_X_CLIPBOARD */

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	status_bar(ST_QUERY_DB);

	open_sep_win_if_need();
	clear_sep_win_if_need();

	gtk_editable_copy_clipboard (GTK_EDITABLE (text1));

	gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), "");
	gtk_editable_paste_clipboard (GTK_EDITABLE (GTK_ENTRY (GTK_COMBO (combo1)->entry)));

#ifdef USE_X_CLIPBOARD
	if (strlen (gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry))) == 0) {
		/* local clipboard empty, try X-wide */
		ptr = get_xclipboard();
		if (ptr != NULL) {
			gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), ptr);
			g_free(ptr);
		}
	}

#endif /* USE_X_CLIPBOARD */

	search_word();

	status_bar(ST_OK);
}


void search_art_sep (void)
{

#ifdef USE_X_CLIPBOARD
	gchar *ptr;
#endif /* USE_X_CLIPBOARD */

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}


	status_bar(ST_QUERY_DB);

	open_sep_win_if_need();
	clear_sep_win_if_need();

	gtk_editable_copy_clipboard (GTK_EDITABLE (text1));
	gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo2)->entry), "");
	gtk_editable_paste_clipboard (GTK_EDITABLE (GTK_ENTRY (GTK_COMBO (combo2)->entry)));

#ifdef USE_X_CLIPBOARD
	if (strlen (gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry))) == 0) {
		/* local clipboard empty, try X-wide */
		ptr = get_xclipboard();
		if (ptr != NULL) {
			gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo2)->entry), ptr);
			g_free(ptr);
		}
	}
#endif /* USE_X_CLIPBOARD */

	search_art();

	status_bar(ST_OK);
}


void status_bar (ST_BAR st_bar)
{
	LOG("changing status bar to: %d", st_bar);

	switch (st_bar) {
	case ST_OK:
		status_bar_dis_all();
		gtk_widget_show(pixmapwid_g);
		break;
	case ST_QUERY_DB:
		status_bar_dis_all();
		gtk_widget_show(pixmapwid_r);
		break;
	case ST_PRINTING:
		status_bar_dis_all();
		gtk_widget_show(pixmapwid_y);
		break;
	default:
		LOG("attempt to set unknown status");
	}

	while (gtk_events_pending()) gtk_main_iteration();
}


static
void status_bar_dis_all(void)
{
	gtk_widget_hide (pixmapwid_g);
	gtk_widget_hide (pixmapwid_r);
	gtk_widget_hide (pixmapwid_y);
}


#ifdef USE_AUDIO


void audio_output(void)
{
	gchar buf[256];

	LOG("audio_output");

	word = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));

	if (word == NULL) {
		LOG("word == NULL");
		return;
	}

	if (strlen(word) == 0) {
		LOG("word len = 0, do nothing");
		return;
	}

	ut_umltotxt (word);
	 
	status_bar(ST_PRINTING);
	set_mw_busy();

	g_snprintf (buf, sizeof(buf), "%s %s", config->speech_prg, word);
	LOG("system >%s<", buf);

	if (system (buf) != 0) {
		LOG("system failed");
		g_snprintf (buf, sizeof(buf),"Seems %s doesn't work properly", config->speech_prg);
		print_err(buf);
	}

	set_mw_norm();
	status_bar(ST_OK);
}
#endif /* USE_AUDIO */


#ifdef USE_EDIT


void update_db(void)
{
	gchar *txt, *r_txt, *r_word;
	gchar *err=NULL;

	LOG("updating db");

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	txt = gtk_editable_get_chars (GTK_EDITABLE (text1), 0, -1);
	word = (gchar*)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));

	if ( (txt==NULL) || (word==NULL) ) {
		LOG("txt or word null");
		return;
	}

	/* i had problem when just use txt and word directly !!! */
	r_txt = g_strdup(txt);
	r_word = g_strdup(word);

	LOG(">%s< >%s<", r_word, r_txt);

	if ( (strlen(r_txt)==0) || (strlen (r_word)==0) ) {

		LOG("text area or word is empty, no action");
		return;
	}
	redraw_text();

	if ((err = db_update_table (r_word, r_txt)) != NULL) {
		print_err(err);
	} else {
		print_msg("Update completed"); 
	}

	g_free(r_txt);
	g_free(r_word);
}


void undo_update_last(void)
{
	gchar *err;

	LOG("undo last");

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	if ((err = db_undo_update_last()) != NULL) {
		print_err(err);
	} else {
		print_msg("Undo last update completed"); 
	}

}


void undo_update_all(void)
{
	gchar *err;

	LOG("undo all");

	if (db_error) {
		LOG("db_error set 1, no action");
		return;
	}

	if ((err = db_undo_update_all()) != NULL) {
		print_err(err);
	} else {
		print_msg("Undo all update completed"); 
	}
}

#endif /* USE_EDIT */


void redraw_text(void)
{
	gchar *txt, *txt2;

	LOG("redrawing text");

	if (strlen (txt = gtk_editable_get_chars (GTK_EDITABLE (text1), 0, -1)) == 0) {
		LOG("text area is empty, no action");
		return;
	}

	if ((txt2 = g_strdup(txt)) == NULL) {
		LOG("null after g_strdup, why?");
		return;
	}
	word = (gchar *) gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));
	if ((word != NULL) && (strlen (word) >0)) { 
		ut_umltotxt (word);
		gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), word);
	}

	gtk_text_freeze (GTK_TEXT(text1));

	clear_text();
	print_text(txt2);

	gtk_text_thaw (GTK_TEXT(text1));

	g_free(txt2);
}


void init_text_w(void)
{
	LOG("initializing text widget");

	gtk_text_insert (GTK_TEXT (text1), font_lat, color_fg, NULL, " ",-1);
	gtk_editable_delete_text(GTK_EDITABLE (text1), 0, gtk_text_get_length (GTK_TEXT(text1)));

}


#ifdef USE_XLIB


guchar *get_xclipboard(void)
{
	guchar *ptr;
	gint i;

	LOG("HERE");
	if ((ptr = get_xclipboard_v()) == NULL) return NULL;

	if (strcmp(xclip_lastword,ptr)!=0) {
		strncpy (xclip_lastword, ptr, sizeof (xclip_lastword)-1);
		return ptr;

	} else {
		LOG("seems xclipboard didn't refresh");

		for (i=0; i<3; i++){
			if ((ptr = get_xclipboard_v()) == NULL) return NULL;
			if (strcmp(xclip_lastword,ptr)!=0) {
				strncpy (xclip_lastword, ptr, sizeof (xclip_lastword)-1);
				return ptr;
			}
		}
	}
	return NULL;
}


static
guchar *get_xclipboard_v(void)
{
        Window Sown;
        Atom type;

        int format, result, i;
        unsigned long len, bytes_left, dummy;
        guchar *data, *ptr;
	
	ptr = NULL;

	for (i = 0; i < 50; i++) {
		Sown = XGetSelectionOwner (dpy, XA_PRIMARY);
		if (Sown != None) {
			XConvertSelection (dpy, XA_PRIMARY,
					   XA_STRING, None,Sown, CurrentTime);
			XFlush (dpy);
			XGetWindowProperty (dpy, Sown, XA_STRING,
					    0, 0, 0, AnyPropertyType,
					    &type, &format, &len, &bytes_left, &data);

			if (bytes_left > 0) {
				result = XGetWindowProperty (dpy, Sown, 
							     XA_STRING,
							     0,bytes_left,0,
							     AnyPropertyType,
							     &type,&format,
							     &len, &dummy, &data);

				if (result == Success) {
					ptr = g_malloc(strlen(data)+1);
					strcpy (ptr, data);
				}
				if (data != NULL) XFree (data);
				if (ptr != NULL) {
					LOG("xclip=%s", ptr);
					return ptr;
				}
			}
		}

	}
	return NULL;
}


#endif /* USE_XLIB */



#ifdef USE_SOCKET


int sock_lsnr_init(void)
{
	int o;
	gchar sock_name[LOCAL_SOCK_SIZE];

/*	LOG("now here"); */

	snprintf (sock_name, sizeof(sock_name),
		  "%s%s",
		  g_get_home_dir(),
		  WORK_DIR
		);

/*	LOG("111>%s<", sock_name  ); */

	unless (access(sock_name, R_OK|W_OK|X_OK)) { /* socket in home dir */

		snprintf (sock_name, sizeof(sock_name),
			  "%s%s/%s",
			  g_get_home_dir(),
			  WORK_DIR,
			  SOCKET_NAME
			);
	} else { /* system wide */

		snprintf (sock_name, sizeof(sock_name),
			  "%s/%s",
			  TMP_DIR,
			  SOCKET_NAME
			);
	}

/*	LOG("222>%s<", sock_name); */

        strncpy (config->sock_lsn, sock_name, sizeof(config->sock_lsn)); 

	unlink (sock_name);
        sock_addr.sun_family = AF_UNIX;
        strncpy(sock_addr.sun_path, sock_name, sizeof (sock_addr.sun_path));

        if ((sock_fd = socket(PF_UNIX, SOCK_DGRAM, 0)) == -1) {
                LOG("socket() error: %s", strerror (errno));
		return FALSE;
        }

        sock_addr_len = sizeof(sock_addr);

        if (bind(sock_fd,&sock_addr,sock_addr_len)!=0) {
                LOG("bind() error: %s", strerror (errno));
                return FALSE;
        }
	chmod (sock_name, SOCKET_PERMS);
        o = fcntl (sock_fd ,F_GETFL);
        if (o < 0) {
                LOG("fcntl() error: %s", strerror(errno));
                return FALSE;
	}
	o = (o|O_NONBLOCK);
	if (fcntl(sock_fd,F_SETFL,o) < 0) {
                LOG("fcntl()error: %s", strerror(errno));
                return FALSE;
	}

        return TRUE;
}


void sock_lsnr(gpointer data,gint source, GdkInputCondition condition)
{
	S_Msg my_msg;
	int rb;
	gchar *ptr, tbuf[256];


	if ((rb = recvfrom(sock_fd, &my_msg, sizeof(my_msg), 0,
                                   &sock_addr, &sock_addr_len)) == -1) {
                LOG("recvfrom() error: %s", strerror(errno));
		return;
        }

	memset(tbuf, 0, sizeof(tbuf));

/*	LOG("received  %d byte(s)", rb); */

	switch (my_msg.cmd) {

	case CMD_CLIPBOARD_SEARCH_WORD:
		status_bar(ST_QUERY_DB);

		strncpy (tbuf,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry)),
			 sizeof(tbuf) -1 );

		gtk_editable_copy_clipboard (GTK_EDITABLE (text1));
		gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo1)->entry), "");
		gtk_editable_paste_clipboard (
			GTK_EDITABLE (GTK_ENTRY (GTK_COMBO (combo1)->entry)));

		if (strlen(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry)))==0){

			ptr = get_xclipboard();
			if ((ptr != NULL)&&(strlen(ptr)>0)) {

				gtk_entry_set_text (
					GTK_ENTRY(GTK_COMBO(combo1)->entry), ptr);
				g_free(ptr);
			}
		} else {

#ifdef GTK_IS_1_2
			(GTK_EDITABLE (text1))->clipboard_text = NULL;
#endif /* GTK_IS_1_2 */

/* TODO */

		}

		if (strlen(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry)))==0){
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo1)->entry), tbuf);
			LOG("combo1->entry empty");
		} else {
			search_word();
		}
			
		status_bar(ST_OK);
		break;

	case CMD_CLIPBOARD_SEARCH_ART:
		status_bar(ST_QUERY_DB);

		strncpy (tbuf,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry)),
			 sizeof(tbuf) -1 );

		gtk_editable_copy_clipboard (GTK_EDITABLE (text1));
		gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(combo2)->entry), "");
		gtk_editable_paste_clipboard (
			GTK_EDITABLE (GTK_ENTRY (GTK_COMBO (combo2)->entry)));

		if (strlen(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry)))==0){

			ptr = get_xclipboard();
			if (ptr != NULL) {
				gtk_entry_set_text (
					GTK_ENTRY(GTK_COMBO(combo2)->entry), ptr);
				g_free(ptr);
			}
		} else {
#ifdef GTK_IS_1_2
			(GTK_EDITABLE (text1))->clipboard_text = NULL;
#endif /* GTK_IS_1_2 */

/* TODO */

		}

		if (strlen(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry)))==0){
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo1)->entry), tbuf);
			LOG("combo1->entry empty");
		} else {
			search_art();
		}
			
		status_bar(ST_OK);
		break;

	case CMD_ICONIFY:
		window_iconify_mw();
		break;

	case CMD_UNICONIFY:
		window_uniconify_mw();
		break;

	case CMD_QUIT_NO_SAVE:
		actual_quit_nosave();
		break;

	default:
		LOG("unknown command: %d", my_msg.cmd);
	}

	return;
}

#endif /* USE_SOCKET */


void search_text(void)
{
	GtkWidget *dialog, *but, *but1, *but2, *but3, *up_box, *mid_box, *lab, *cb1;
	gchar *mptr;

	LOG("now here");

	define_output_window();

	if (strlen (search_txt_ptr = gtk_editable_get_chars (GTK_EDITABLE (text_output), 0, -1)) == 0) {
		LOG("text area is empty, no action");
		return;
	}

	err_stop = no_more_search = 1;
	search_sm = search_pos = search_tr = search_adj = 0;

	dialog =  gtk_dialog_new ();
	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_widget_realize(dialog);

	gdk_window_set_decorations(GTK_WIDGET(dialog)->window,GDK_DECOR_TITLE|GDK_DECOR_BORDER|GDK_DECOR_MENU|GDK_DECOR_MINIMIZE);
	gdk_window_set_functions (GTK_WIDGET(dialog)->window, GDK_FUNC_MOVE);
	set_window_icon(GTK_WIDGET(dialog));
	gtk_window_set_title(GTK_WINDOW(dialog), "Find window");
	gtk_widget_show(dialog);

	gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);

	gtk_container_border_width(GTK_CONTAINER(dialog), 5);

	gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",(GtkSignalFunc) destroy_search,GTK_OBJECT(dialog));

	up_box = gtk_hbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(up_box), SPACE);
	gtk_box_pack_start(GTK_BOX (GTK_DIALOG (dialog)->vbox), up_box, FALSE, FALSE, 0);

	mid_box = gtk_hbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(mid_box), SPACE);
	gtk_box_pack_start(GTK_BOX (GTK_DIALOG (dialog)->vbox), mid_box, FALSE, FALSE, 10);

	cb1 = gtk_check_button_new_with_label("Leave marks");
	gtk_box_pack_start (GTK_BOX (mid_box), cb1, FALSE, FALSE, 10);

	gtk_signal_connect (GTK_OBJECT (cb1), "clicked", GTK_SIGNAL_FUNC (toggle_search_sm), cb1 );
        if (search_sm) {
                gtk_toggle_button_set_active ((GtkToggleButton*)cb1, TRUE);
        }


	lab = gtk_label_new ("Find:");
	gtk_box_pack_start (GTK_BOX (up_box), lab, TRUE, TRUE, 10);

	entry1 = gtk_entry_new();
	gtk_box_pack_start (GTK_BOX (up_box), entry1, TRUE, TRUE, 10);

#ifdef GTK_IS_1_2
	gtk_signal_connect_object(GTK_OBJECT (GTK_ENTRY(entry1)) , "key_press_event", search_entry_cb, GTK_OBJECT (GTK_ENTRY(entry1)));
#endif /* GTK_IS_1_2 */

#ifdef GTK_IS_2_0
	gtk_signal_connect_object(GTK_OBJECT (GTK_ENTRY(entry1)),
				  "key_press_event",
				  GTK_SIGNAL_FUNC(search_entry_cb),
				  entry1
		);
#endif /* GTK_IS_1_2 */



	but1 = gtk_button_new_with_label( "Switch font" );
	gtk_box_pack_start (GTK_BOX (up_box),but1, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but1),"clicked",GTK_SIGNAL_FUNC(search_switch_font),GTK_OBJECT(dialog));

	if (style_left == style_lat) {
		gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(entry1)), style_lat);
		search_font = 0;
	} else { 
		gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(entry1)), style_rus);
		search_font = 1;
	}

	mptr = (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));
	
	if (strlen(mptr) != 0) {
		LOG("ok, setting entry from word combo");
		gtk_entry_set_text(GTK_ENTRY(entry1),mptr);
	} else {
		mptr =  (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo2)->entry));
		if (strlen(mptr) != 0) {
			LOG("ok, setting entry from art combo");
			gtk_entry_set_text(GTK_ENTRY(entry1),mptr);
		}
	}

	but = gtk_button_new_with_label( "Find" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but),"clicked",GTK_SIGNAL_FUNC(actual_search),GTK_OBJECT(dialog));

	but3 = gtk_button_new_with_label( "Find all" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but3, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but3),"clicked",GTK_SIGNAL_FUNC(actual_search_all),GTK_OBJECT(dialog));

	but2 = gtk_button_new_with_label( "Close" );
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),but2, TRUE, TRUE, 10);
	gtk_signal_connect_object(GTK_OBJECT(but2),"clicked",GTK_SIGNAL_FUNC(destroy_search),GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);

	while (err_stop) {
		gtk_main_iteration();
	}
}


static
void toggle_search_sm(GtkWidget *widget, gpointer data)
{
        if (GTK_TOGGLE_BUTTON (widget)->active) {
                search_sm = TRUE;
        } else {
                search_sm = FALSE;
        }
        LOG("search_sm = %d", search_sm);
}               


static 
void search_switch_font(GtkWidget *d)
{
	LOG("switch search entry font");

	if (search_font != 0) {
		gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(entry1)), style_lat);
		search_font = 0;
	} else { 
		gtk_widget_set_style (GTK_WIDGET(GTK_ENTRY(entry1)), style_rus);
		search_font = 1;
	}
}


static
void destroy_search (GtkWidget *d)
{
	LOG("destroying");
	/* redraw_text(); */
	gtk_widget_destroy(d);
	err_stop=0;
}


static
void actual_search (GtkWidget *d)
{
	gchar *en_t_ptr;
	gchar word_buf[256];

	static gchar *prev_txt_ptr;
	static gchar *cur_txt_ptr;

	en_t_ptr = (gchar *) gtk_entry_get_text(GTK_ENTRY(entry1));
	strncpy (word_buf, en_t_ptr, sizeof(word_buf) -1);
	ut_umltotxt (word_buf);
	
	if (strlen(en_t_ptr) == 0) {
		LOG("nothing in entry");
		return;
	}

	gtk_entry_set_text(GTK_ENTRY(entry1),word_buf);

	if (search_tr == 0) {

		LOG("first search");

		if ((cur_txt_ptr = strstr(search_txt_ptr, word_buf)) == NULL) {
			LOG("no match");
			no_more_search = 0;
			return;
		} else {
			search_pos = cur_txt_ptr - search_txt_ptr;
			prev_txt_ptr = ++cur_txt_ptr;
			search_tr=1;
			set_search_mark(search_pos);
			return;
		}

	} else {

		LOG("continued search");
		if ((cur_txt_ptr = strstr(prev_txt_ptr, word_buf)) == NULL) {
			LOG("no more match");
			no_more_search = 0;
			return;
		} else {


			if (!search_sm) {
				if (search_pos !=0) {
					del_search_mark(search_pos - 1 + search_adj);

				} else {
					del_search_mark(search_pos);
				}
				if (search_adj > 0) search_adj--;
			}

			search_pos = cur_txt_ptr - search_txt_ptr;
			prev_txt_ptr = ++cur_txt_ptr;

			set_search_mark(search_pos);
			return;
		}
	}
}

static
void actual_search_all (GtkWidget *d)
{
	search_sm = 1;
	gtk_text_freeze (GTK_TEXT(text_output));
	while (no_more_search) {
		actual_search (d);
	}
	gtk_text_thaw(GTK_TEXT(text_output));
	gtk_adjustment_set_value (GTK_TEXT(text_output)->vadj, search_pos);
}


static
void set_search_mark(guint pos)
{
	gtk_text_freeze (GTK_TEXT(text_output));

	gtk_text_set_point (GTK_TEXT (text_output), pos + search_adj++);
	gtk_text_insert (GTK_TEXT (text_output), font_lat, color_sel_fg, color_sel_bg, " ", 1);
	gtk_text_thaw(GTK_TEXT(text_output));

	gtk_text_set_point (GTK_TEXT (text_output), pos + search_adj);
	gtk_text_insert (GTK_TEXT (text_output), font_lat, NULL, NULL, " ", 1);
	gtk_text_backward_delete (GTK_TEXT(text_output), 1);
}


static
void del_search_mark(guint pos)
{
	gtk_text_freeze (GTK_TEXT(text_output));
	gtk_text_set_point (GTK_TEXT (text_output), pos);
	gtk_text_forward_delete (GTK_TEXT(text_output), 1);
	gtk_text_thaw(GTK_TEXT(text_output));
}


static
void search_entry_cb (GtkWidget* widget, GdkEventKey* event, gpointer data)
{
	gint ev;

	ev = event->type;
        /* LOG("event->type = %d", ev); */

	switch (event->keyval) {

	case GDK_Escape:
		LOG("Escape");
		gtk_entry_set_text (GTK_ENTRY(widget), "");
		break;
	case GDK_Return:
		LOG("Return");
		actual_search(widget);
		break;
	}
}


void window_iconify (GdkWindow *w)
{
	g_return_if_fail (w != NULL);
 	/* gdk_window_hide (GTK_WIDGET(mw)->window); */
	XIconifyWindow (dpy, GDK_WINDOW_XWINDOW (w), DefaultScreen (dpy));
}


void window_uniconify (GdkWindow *w)
{
	g_return_if_fail (w != NULL);
	gdk_window_show (GTK_WIDGET(mw)->window);
	gdk_window_raise (GTK_WIDGET(mw)->window);

	LOG("grab focus");
	gtk_widget_grab_focus(GTK_WIDGET(GTK_COMBO(combo1)->entry) );
}


void window_iconify_mw(void)
{
	window_iconify(GTK_WIDGET(mw)->window);
}


void window_uniconify_mw(void)
{
	window_uniconify(GTK_WIDGET(mw)->window);
}



/* __END__ */
