/* $Id: gtkdic_cb.h,v 1.25 2003/01/24 18:47:21 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#ifndef __GTKDIC_CB_H_
#define __GTKDIC_CB_H_ 1


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <glib.h>
#include <mysql.h>
#include <gtk/gtk.h>
#include <gtk/gtkhbox.h>

#ifdef GTK_IS_2_0
#define GTK_ENABLE_BROKEN 1
#include <gtk/gtktext.h>
#endif /* GTK_IS_2_0 */

#include <gdk/gdkkeysyms.h>
#include <gdk/gdkx.h> 
#include <X11/Xatom.h>

#ifdef USE_SOCKET
#include <sys/socket.h>
#include <sys/un.h>
#endif /* USE_SOCKET */

#include "logging.h"
#include "cfg.h"
#include "db_sql.h"
#include "util.h"
#include "gtkdic.h"
#include "defs.h"


typedef enum {
        ST_OK,
        ST_QUERY_DB,
	ST_PRINTING
} ST_BAR;


void status_bar (ST_BAR);
void about_quit (void);
void print_err (gchar*);
void print_msg (gchar*);
void change_dic (GtkWidget*);
void change_dic_v (gchar*);
void clear_text(void);
void search_word(void);
void search_art(void);
void print_text (gchar*);
void print_text_with_separator_after (gchar*);
void about_dialog(void);
void settings(void);
void print_out(void);
void history_word(GtkWidget*, GdkEventKey*, gpointer);
void history_art(GtkWidget*, GdkEventKey*, gpointer);
void clear_txt_if_need (void);
void set_mw_norm (void);
void set_mw_busy (void);
void init_styles(void);
void save_file(void);
void open_file(void);
void clear_text_entry (GtkWidget*);
void actual_quit(void);
void actual_quit_nosave(void);
void new_window(void);
void text1_key_cb(GtkWidget*, GdkEventKey*, gpointer);
void text1_mouse_cb(GtkWidget*, GdkEventKey*, gpointer);
void altq_key_cb(GtkWidget*, GdkEventKey*, gpointer);
void search_word_sep (void);
void search_art_sep (void);
void redraw_text(void);
void define_output_window(void);
void define_output_window1(void);


#ifdef USE_EDIT
void update_db(void);
void undo_update_last(void);
void undo_update_all(void); 
#endif /* USE_EDIT */


#ifdef USE_AUDIO
void audio_output(void);
#endif /* USE_AUDIO */

void init_text_w(void);
void search_text(void);
void window_iconify (GdkWindow*);
void window_uniconify (GdkWindow*);
void window_iconify_mw(void);
void window_uniconify_mw(void);

#ifdef USE_X_CLIPBOARD
guchar *get_xclipboard(void);
guchar xclip_lastword[256];
#endif /* USE_X_CLIPBOARD */

#ifdef USE_SOCKET
int sock_lsnr_init(void); 
void sock_lsnr (gpointer data,gint source, GdkInputCondition condition);
#endif /* USE_SOCKET */


#ifdef  __GTKDIC_CB_C_ /* Private declarations */

#ifdef USE_SOCKET
int sock_fd;
struct sockaddr_un sock_addr;
int sock_addr_len;

#ifndef SOCKET_PERMS
#define SOCKET_PERMS (S_IRUSR | S_IWUSR)
#endif

#endif /* USE_SOCKET */

#define MAX_SEARCH_EXCEEDED_MSG "\n*** MAX SEARCH MATCHES EXCEEDED ***"
#define MAX_SEARCH_IN_INCREMENT 1


typedef enum {
	PR_MSG,
	PR_ERR
} PR_MODE; 


#ifdef USE_SOCKET
#include "gtkdic_gdata.h"
#endif /* USE_SOCKET */

#define STATUS_OK "Ready"
#define STATUS_QUERY_DB "Querying database..."

#ifndef SEARCH_SEPARATOR
#define SEARCH_SEPARATOR "."
#endif


static void print_err_v (PR_MODE, gchar*);
static void destroy_dialog (GtkWidget*);
static void destroy_about_dialog (GtkWidget*);
static void destroy_settings (GtkWidget*);
static void word_search_mode1 (GtkWidget*, gpointer);
static void word_search_mode2 (GtkWidget*, gpointer);
static void word_search_mode3 (GtkWidget*, gpointer);
static void word_search_mode4 (GtkWidget*, gpointer);
static void art_search_mode1 (GtkWidget*, gpointer);
static void art_search_mode2 (GtkWidget*, gpointer);
static void destroy_dialog (GtkWidget*);
static void art_search_mode3 (GtkWidget*, gpointer);
static void art_search_mode4 (GtkWidget*, gpointer);
static void toggle_clear (GtkWidget*, gpointer);
static void change_max_search(GtkWidget *, GtkSpinButton*);
static void destroy_about_quit_no (GtkWidget*);
static void destroy_about_quit_yes (GtkWidget*);
static void stop_signal_emit (GtkWidget *, gint);
static void my_gtk_combo_set_popdown_strings_l (GtkCombo*, GList*);
static void my_gtk_combo_set_popdown_strings_r (GtkCombo*, GList*);
static void my_gtk_combo_set_popdown_strings (GtkCombo*, GList*, GtkStyle*);
static GtkWidget* my_gtk_list_item_new_with_label (const gchar*, GtkStyle*);
static void file_ok_sel( GtkWidget*, GtkFileSelection*);
static void destroy_save_file (GtkWidget*);
static void open_sep_win(void);
static void open_sep_win_if_need(void);
static void clear_sep_win_if_need(void);
static void clear_text_sep(void);
static void destroy_sepwin (GtkWidget*);
static void setup_def_file (GtkWidget*);
static void status_bar_dis_all(void);
static void clear_any_txt(void);
static void destroy_search (GtkWidget*);
static void actual_search (GtkWidget*);
static void set_search_mark(guint);
static void del_search_mark(guint);
static void search_switch_font(GtkWidget*);
static void search_entry_cb (GtkWidget*, GdkEventKey*, gpointer);
static void actual_search_all (GtkWidget*);
static void toggle_search_sm(GtkWidget*, gpointer);


#ifdef USE_X_CLIPBOARD
static guchar *get_xclipboard_v(void);
#endif /* USE_X_CLIPBOARD */


extern GSList* tinfo;
extern GdkFont *font_lat, *font_latb, *font_rus, *font_rusb;
extern GtkWidget *combo1, *combo2;
extern GtkWidget *lab1, *lab2, *lab3;
extern GtkWidget *mw, *text1, *text2, *text_output;
extern gchar *word;
extern gchar *art;
extern gint disable_settings;
extern Cfg *config;
extern GdkCursor *norm_cursor, *busy_cursor;
extern gchar *word_history [HIST_LEN];
extern gchar *art_history  [HIST_LEN];
extern Cfg* config;
extern gchar prog_name[256];
extern GtkWidget *pixmapwid_g, *pixmapwid_r, *pixmapwid_y;
extern GtkWidget *box4r;
extern gchar db_table[64];
extern gint db_error;


gint disable_settings;
gint disable_about;
gchar file_save_name[512];
gchar current_dic[256];
gint nsconf = 1;


static gchar increment_word[128];
static gint err_stop = 0;
static gint file_ok = 0;
static MYSQL_ROW* my_row;
static GtkStyle *style_def, *style_lat, *style_latb, *style_rus,
	        *style_rusb, *style_left, *style_right;
static GdkColor *color_fg, *color_bg, *color_sel_fg, *color_sel_bg;
extern Display *dpy;
static gint search_tr, search_pos, search_adj, search_font, no_more_search, search_sm;
static gchar *search_txt_ptr;
static GtkWidget *entry1;

#include "logo.xpm"

#endif  /* __GTKDIC_CB_C_ */


#endif /* __GTKDIC_CB_H_ */



/* __END__ */
