/* $Id: util.h,v 1.12 2003/01/24 18:47:21 swaj Exp $ */

/*
 * Was written by Alexey Semenov (c) 2001-2003
 * See COPYING for copying policy
 */


#ifndef __UTIL_H_
#define __UTIL_H_ 1


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif

#include <string.h>

#ifdef HAVE_GLIB_H
#include <glib.h>
#endif


#include "defs.h"
#include "logging.h"


#define HIST_ITEM_LEN 64

#ifndef HIST_LEN 
#define HIST_LEN 20
#endif

#define WORD_MAX_LEN 3*128

#define CR '\r'
#define TAB '\t'
#define NL '\n'
#define CR_REPL ' '


void ut_mask_sigsegv (void);
void ut_sigsegv_handler (gint);
void ut_umltotxt (gchar *);
gint ut_is_word_latin (gchar *);
gint ut_is_word_bold (gchar *w);
void ut_slist_free (GSList*);
void ut_init_history (void);
void ut_insert_history_word (gchar*);
void ut_insert_history_art (gchar*);
gchar* ut_fetch_history_word_up (void);
gchar* ut_fetch_history_word_down (void);
gchar* ut_fetch_history_art_up (void);
gchar* ut_fetch_history_art_down (void);
gchar* ut_add_uml (gchar*);
gint ut_is_line_empty (gchar*);
void ut_replace_control (unsigned char*);



#ifdef  __UTIL_C_ /* Private declarations */

static void ut_insert_history (gchar*, gchar **, gint*);
static gchar* ut_fetch_history (gchar **, gint*);


gchar *word_history [HIST_LEN];
gchar *art_history  [HIST_LEN];

static gint word_history_ptr;
static gint art_history_ptr;
static gint word_history_len;
static gint art_history_len;

#endif /* __UTIL_C_ */



#endif /* __UTIL_H_ */



/* __END__ */
